import * as i0 from '@angular/core';
import { Component, Input, ViewChild, Injectable, EventEmitter, Inject, Output, NgModule, ViewEncapsulation, NO_ERRORS_SCHEMA } from '@angular/core';
import * as i4$1 from '@angular/material/paginator';
import { MatPaginator, MatPaginatorModule } from '@angular/material/paginator';
import * as i5$1 from '@angular/material/sort';
import { MatSort, MatSortModule } from '@angular/material/sort';
import * as i4 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i5 from '@angular/material/chips';
import { MatChipsModule } from '@angular/material/chips';
import * as i2 from '@angular/material/table';
import { MatTableModule } from '@angular/material/table';
import * as i1 from '@ngx-translate/core';
import { TranslateModule } from '@ngx-translate/core';
import * as i1$1 from '@angular/forms';
import { Validators, FormsModule, ReactiveFormsModule } from '@angular/forms';
import { LABEL_ASPECT } from '@yukawa/chain-main-angular-core';
import { BehaviorSubject, Subject, fromEvent } from 'rxjs';
import _ from 'lodash';
import { debounceTime, distinctUntilChanged, map } from 'rxjs/operators';
import * as i3 from 'ngx-color-picker';
import { ColorPickerModule } from 'ngx-color-picker';
import * as i6 from '@angular/material/list';
import { MatListModule } from '@angular/material/list';
import * as i7 from '@angular/material/icon';
import { MatIconModule } from '@angular/material/icon';
import * as i8 from '@angular/material/form-field';
import * as i9 from '@angular/material/input';
import { MatInputModule } from '@angular/material/input';
import * as i10 from '@angular/material/button';
import { MatButtonModule } from '@angular/material/button';
import * as i11 from 'ng-click-outside';
import { ClickOutsideModule } from 'ng-click-outside';
import * as i12 from '@angular/flex-layout';
import { FlexModule, FlexLayoutModule } from '@angular/flex-layout';
import { MatSelectModule } from '@angular/material/select';
import { MatCardModule } from '@angular/material/card';
import * as i3$1 from '@angular/material/tooltip';
import { MatTooltipModule } from '@angular/material/tooltip';
import * as i6$1 from '@angular/material/toolbar';
import { MatToolbarModule } from '@angular/material/toolbar';
import * as i10$1 from '@yukawa/chain-base-angular-comp';
import { ChainBaseComp } from '@yukawa/chain-base-angular-comp';
import { QueryTableSource } from '@yukawa/chain-base-angular-store';
import * as i2$1 from '@yukawa/chain-base-angular-client';
import { RestAspect } from '@yukawa/chain-base-angular-client';
import * as i1$2 from '@angular/common/http';
import * as i11$1 from '@angular/cdk/table';
import { CdkTableModule } from '@angular/cdk/table';

function LabelTableComponent_div_0_mat_header_cell_4_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementStart(0, "mat-header-cell");
        i0.ɵɵtext(1);
        i0.ɵɵpipe(2, "translate");
        i0.ɵɵelementEnd();
    }
    if (rf & 2) {
        i0.ɵɵadvance(1);
        i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "HEADER.NAME"));
    }
}
const _c0$4 = function (a0) { return { "background-color": a0 }; };
function LabelTableComponent_div_0_mat_cell_5_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementStart(0, "mat-cell")(1, "mat-chip-list")(2, "mat-chip", 9);
        i0.ɵɵtext(3);
        i0.ɵɵelementEnd()()();
    }
    if (rf & 2) {
        const row_r6 = ctx.$implicit;
        i0.ɵɵadvance(2);
        i0.ɵɵproperty("ngStyle", i0.ɵɵpureFunction1(2, _c0$4, row_r6 == null ? null : row_r6.colorCode));
        i0.ɵɵadvance(1);
        i0.ɵɵtextInterpolate(row_r6.name);
    }
}
function LabelTableComponent_div_0_mat_header_row_6_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelement(0, "mat-header-row");
    }
}
function LabelTableComponent_div_0_mat_row_7_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelement(0, "mat-row");
    }
}
function LabelTableComponent_div_0_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementStart(0, "div", 1)(1, "mat-table", 2, 3);
        i0.ɵɵelementContainerStart(3, 4);
        i0.ɵɵtemplate(4, LabelTableComponent_div_0_mat_header_cell_4_Template, 3, 3, "mat-header-cell", 5);
        i0.ɵɵtemplate(5, LabelTableComponent_div_0_mat_cell_5_Template, 4, 4, "mat-cell", 6);
        i0.ɵɵelementContainerEnd();
        i0.ɵɵtemplate(6, LabelTableComponent_div_0_mat_header_row_6_Template, 1, 0, "mat-header-row", 7);
        i0.ɵɵtemplate(7, LabelTableComponent_div_0_mat_row_7_Template, 1, 0, "mat-row", 8);
        i0.ɵɵelementEnd()();
    }
    if (rf & 2) {
        const ctx_r0 = i0.ɵɵnextContext();
        i0.ɵɵadvance(1);
        i0.ɵɵproperty("dataSource", ctx_r0.dataSource);
        i0.ɵɵadvance(5);
        i0.ɵɵproperty("matHeaderRowDef", ctx_r0.displayedColumns);
        i0.ɵɵadvance(1);
        i0.ɵɵproperty("matRowDefColumns", ctx_r0.displayedColumns);
    }
}
const TAG$4 = 'LabelTableComponent';
class LabelTableComponent {
    constructor() {
        this.displayedColumns = ['name'];
    }
    ngOnInit() {
        console.debug(TAG$4, this.dataSource);
    }
}
/** @nocollapse */ LabelTableComponent.ɵfac = function LabelTableComponent_Factory(t) { return new (t || LabelTableComponent)(); };
/** @nocollapse */ LabelTableComponent.ɵcmp = /** @pureOrBreakMyCode */ i0.ɵɵdefineComponent({ type: LabelTableComponent, selectors: [["chain-main-label-table"]], viewQuery: function LabelTableComponent_Query(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵviewQuery(MatPaginator, 7);
            i0.ɵɵviewQuery(MatSort, 7);
        }
        if (rf & 2) {
            let _t;
            i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.paginator = _t.first);
            i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.sort = _t.first);
        }
    }, inputs: { displayedColumns: "displayedColumns", labelFilter: "labelFilter", dataSource: "dataSource" }, decls: 1, vars: 1, consts: [["class", "table-layout-1", 4, "ngIf"], [1, "table-layout-1"], [3, "dataSource"], ["table", ""], ["matColumnDef", "name"], [4, "matHeaderCellDef"], [4, "matCellDef"], [4, "matHeaderRowDef"], [4, "matRowDef", "matRowDefColumns"], [3, "ngStyle"]], template: function LabelTableComponent_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵtemplate(0, LabelTableComponent_div_0_Template, 8, 3, "div", 0);
        }
        if (rf & 2) {
            i0.ɵɵproperty("ngIf", ctx.dataSource);
        }
    }, dependencies: [i4.NgIf, i4.NgStyle, i5.MatChipList, i5.MatChip, i2.MatTable, i2.MatHeaderCellDef, i2.MatHeaderRowDef, i2.MatColumnDef, i2.MatCellDef, i2.MatRowDef, i2.MatHeaderCell, i2.MatCell, i2.MatHeaderRow, i2.MatRow, i1.TranslatePipe] });
(function () {
    (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(LabelTableComponent, [{
            type: Component,
            args: [{ selector: 'chain-main-label-table', template: "<div class=\"table-layout-1\" *ngIf=\"dataSource\">\n\n  <mat-table #table [dataSource]=\"dataSource\">\n    <!-- username Column -->\n    <ng-container matColumnDef=\"name\">\n      <mat-header-cell *matHeaderCellDef>{{'HEADER.NAME' | translate}}</mat-header-cell>\n      <mat-cell *matCellDef=\"let row\">\n        <mat-chip-list>\n          <mat-chip [ngStyle]=\"{'background-color': row?.colorCode}\">{{row.name}}</mat-chip>\n        </mat-chip-list>\n      </mat-cell>\n    </ng-container>\n\n    <mat-header-row *matHeaderRowDef=\"displayedColumns\"></mat-header-row>\n    <mat-row *matRowDef=\"let row; columns: displayedColumns;\"></mat-row>\n  </mat-table>\n\n</div>\n" }]
        }], function () { return []; }, { displayedColumns: [{
                type: Input
            }], labelFilter: [{
                type: Input
            }], dataSource: [{
                type: Input
            }], paginator: [{
                type: ViewChild,
                args: [MatPaginator, { static: true }]
            }], sort: [{
                type: ViewChild,
                args: [MatSort, { static: true }]
            }] });
})();

class LabelEditService {
    constructor() {
        this._labelManagementShown = new BehaviorSubject(false);
        this._selectedLabels = new BehaviorSubject([]);
    }
    showLabelManagement() {
        this.labelManagementShown.next(true);
    }
    hideLabelManagement() {
        this.labelManagementShown.next(false);
    }
    toggleLabelManagement() {
        this.labelManagementShown.next(!this.labelManagementShown.value);
    }
    get labelManagementShown() {
        return this._labelManagementShown;
    }
    get selectedLabels() {
        return this._selectedLabels;
    }
    setSelectedLabels(labels) {
        this.selectedLabels.next(labels);
    }
}
/** @nocollapse */ LabelEditService.ɵfac = function LabelEditService_Factory(t) { return new (t || LabelEditService)(); };
/** @nocollapse */ LabelEditService.ɵprov = /** @pureOrBreakMyCode */ i0.ɵɵdefineInjectable({ token: LabelEditService, factory: LabelEditService.ɵfac });
(function () {
    (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(LabelEditService, [{
            type: Injectable
        }], function () { return []; }, null);
})();

const _c0$3 = function (a0) { return { "background-color": a0 }; };
function LabelingComponent_mat_chip_3_Template(rf, ctx) {
    if (rf & 1) {
        const _r5 = i0.ɵɵgetCurrentView();
        i0.ɵɵelementStart(0, "mat-chip", 3);
        i0.ɵɵlistener("removed", function LabelingComponent_mat_chip_3_Template_mat_chip_removed_0_listener() { const restoredCtx = i0.ɵɵrestoreView(_r5); const i_r3 = restoredCtx.index; const ctx_r4 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r4.removeLabelFromSelection(i_r3)); });
        i0.ɵɵtext(1);
        i0.ɵɵelementStart(2, "mat-icon", 4);
        i0.ɵɵtext(3, "cancel");
        i0.ɵɵelementEnd()();
    }
    if (rf & 2) {
        const label_r2 = ctx.$implicit;
        i0.ɵɵproperty("ngStyle", i0.ɵɵpureFunction1(2, _c0$3, label_r2.colorCode));
        i0.ɵɵadvance(1);
        i0.ɵɵtextInterpolate1(" ", label_r2.name, " ");
    }
}
function LabelingComponent_div_5_mat_list_option_8_Template(rf, ctx) {
    if (rf & 1) {
        const _r11 = i0.ɵɵgetCurrentView();
        i0.ɵɵelementStart(0, "mat-list-option", 18)(1, "div", 19)(2, "div");
        i0.ɵɵtext(3);
        i0.ɵɵelementEnd();
        i0.ɵɵelementStart(4, "mat-icon", 20);
        i0.ɵɵlistener("click", function LabelingComponent_div_5_mat_list_option_8_Template_mat_icon_click_4_listener($event) { const restoredCtx = i0.ɵɵrestoreView(_r11); const label_r9 = restoredCtx.$implicit; const ctx_r10 = i0.ɵɵnextContext(2); return i0.ɵɵresetView(ctx_r10.deleteLabel($event, label_r9.id)); });
        i0.ɵɵtext(5, "delete");
        i0.ɵɵelementEnd()()();
    }
    if (rf & 2) {
        const label_r9 = ctx.$implicit;
        i0.ɵɵproperty("value", label_r9)("ngStyle", i0.ɵɵpureFunction1(3, _c0$3, label_r9.colorCode));
        i0.ɵɵadvance(3);
        i0.ɵɵtextInterpolate(label_r9.name);
    }
}
function LabelingComponent_div_5_div_15_Template(rf, ctx) {
    if (rf & 1) {
        const _r13 = i0.ɵɵgetCurrentView();
        i0.ɵɵelementStart(0, "div", 14);
        i0.ɵɵelement(1, "input", 21);
        i0.ɵɵelementStart(2, "span", 22);
        i0.ɵɵlistener("colorPickerChange", function LabelingComponent_div_5_div_15_Template_span_colorPickerChange_2_listener($event) { i0.ɵɵrestoreView(_r13); const ctx_r12 = i0.ɵɵnextContext(2); return i0.ɵɵresetView(ctx_r12.pickedColor = $event); })("colorPickerChange", function LabelingComponent_div_5_div_15_Template_span_colorPickerChange_2_listener($event) { i0.ɵɵrestoreView(_r13); const ctx_r14 = i0.ɵɵnextContext(2); return i0.ɵɵresetView(ctx_r14.colorPickerChange($event)); });
        i0.ɵɵelementEnd();
        i0.ɵɵelementStart(3, "button", 23);
        i0.ɵɵlistener("click", function LabelingComponent_div_5_div_15_Template_button_click_3_listener() { i0.ɵɵrestoreView(_r13); const ctx_r15 = i0.ɵɵnextContext(2); return i0.ɵɵresetView(ctx_r15.createNewLabel()); });
        i0.ɵɵtext(4);
        i0.ɵɵpipe(5, "translate");
        i0.ɵɵelementEnd()();
    }
    if (rf & 2) {
        const ctx_r8 = i0.ɵɵnextContext(2);
        i0.ɵɵadvance(2);
        i0.ɵɵstyleProp("background", ctx_r8.pickedColor);
        i0.ɵɵproperty("cpToggle", true)("cpDialogDisplay", "inline")("cpDisableInput", true)("colorPicker", ctx_r8.pickedColor);
        i0.ɵɵadvance(1);
        i0.ɵɵproperty("disabled", ctx_r8.newLabel.invalid);
        i0.ɵɵadvance(1);
        i0.ɵɵtextInterpolate1(" ", i0.ɵɵpipeBind1(5, 8, "CMD.ADD"), " ");
    }
}
const _c1$3 = function (a0) { return { "color": a0 }; };
function LabelingComponent_div_5_Template(rf, ctx) {
    if (rf & 1) {
        const _r17 = i0.ɵɵgetCurrentView();
        i0.ɵɵelementStart(0, "div", 5)(1, "mat-form-field", 6);
        i0.ɵɵelement(2, "input", 7);
        i0.ɵɵpipe(3, "translate");
        i0.ɵɵelementEnd();
        i0.ɵɵelementStart(4, "div", 8)(5, "mat-selection-list", 9, 10);
        i0.ɵɵlistener("ngModelChange", function LabelingComponent_div_5_Template_mat_selection_list_ngModelChange_5_listener($event) { i0.ɵɵrestoreView(_r17); const ctx_r16 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r16.selectedLabels.next($event)); });
        i0.ɵɵpipe(7, "async");
        i0.ɵɵtemplate(8, LabelingComponent_div_5_mat_list_option_8_Template, 6, 5, "mat-list-option", 11);
        i0.ɵɵelementEnd()();
        i0.ɵɵelementStart(9, "div", 12);
        i0.ɵɵlistener("clickOutside", function LabelingComponent_div_5_Template_div_clickOutside_9_listener() { i0.ɵɵrestoreView(_r17); const ctx_r18 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r18.showAddLabelBox = false); });
        i0.ɵɵelementStart(10, "form", 13)(11, "div", 14)(12, "mat-form-field", 15)(13, "input", 16);
        i0.ɵɵlistener("click", function LabelingComponent_div_5_Template_input_click_13_listener() { i0.ɵɵrestoreView(_r17); const ctx_r19 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r19.showAddLabelBox = true); });
        i0.ɵɵpipe(14, "translate");
        i0.ɵɵelementEnd()();
        i0.ɵɵtemplate(15, LabelingComponent_div_5_div_15_Template, 6, 10, "div", 17);
        i0.ɵɵelementEnd()()()();
    }
    if (rf & 2) {
        const ctx_r1 = i0.ɵɵnextContext();
        i0.ɵɵadvance(2);
        i0.ɵɵpropertyInterpolate("placeholder", i0.ɵɵpipeBind1(3, 8, "CMD.FIND"));
        i0.ɵɵadvance(3);
        i0.ɵɵproperty("ngModel", i0.ɵɵpipeBind1(7, 10, ctx_r1.selectedLabels))("compareWith", ctx_r1.compareLabels);
        i0.ɵɵadvance(3);
        i0.ɵɵproperty("ngForOf", ctx_r1.labelList);
        i0.ɵɵadvance(2);
        i0.ɵɵproperty("formGroup", ctx_r1.newLabel);
        i0.ɵɵadvance(3);
        i0.ɵɵpropertyInterpolate("placeholder", i0.ɵɵpipeBind1(14, 12, "LABEL.ADD_NEW"));
        i0.ɵɵproperty("ngStyle", i0.ɵɵpureFunction1(14, _c1$3, ctx_r1.newLabel.value.colorCode));
        i0.ɵɵadvance(2);
        i0.ɵɵproperty("ngIf", ctx_r1.showAddLabelBox);
    }
}
const TAG$3 = "LabelingComponent";
class LabelingComponent {
    constructor(_formBuilder, labelEditService, labelAspect) {
        this._formBuilder = _formBuilder;
        this.labelEditService = labelEditService;
        this.labelAspect = labelAspect;
        this.labelAdded = new EventEmitter();
        this.navigateToAllLabels = new EventEmitter();
        this.debouncer = new Subject();
        this.showAddLabelBox = false;
        this.debouncer.pipe(debounceTime(100))
            .subscribe(color => this.newLabel.get("colorCode").patchValue(color));
    }
    ngOnInit() {
        this.selectedLabels = this.labelEditService.selectedLabels;
        this.newLabel = this._formBuilder.group({
            name: [null, [Validators.required]],
            colorCode: [null, [Validators.required]]
        });
        if (!this.labelList && this.labelAspect) {
            this.labelAspect.queryLabel({ pager: { pageSize: 10000, firstResult: 0 } })
                .subscribe(value => {
                this.labelList = value.items;
            });
        }
    }
    createNewLabel() {
        console.debug(TAG$3, "new label: ", this.newLabel.value);
        this.labelAspect.createLabel(this.newLabel.value)
            .subscribe(value => {
            this.labelList.push(value);
            this.labelAdded.emit(this.newLabel.value);
            this.newLabel.reset();
            this.showAddLabelBox = false;
        });
    }
    deleteLabel(event, labelId) {
        event.stopPropagation();
        this.labelAspect.deleteLabel(labelId).subscribe(() => {
            this.labelList.splice(this.labelList.map(label => label.id).indexOf(labelId), 1);
        });
    }
    colorPickerChange(color) {
        this.debouncer.next(color);
    }
    compareLabels(label1, label2) {
        return label1.id === label2.id;
    }
    removeLabelFromSelection(i) {
        let copy = _.cloneDeep(this.selectedLabels.value);
        copy.splice(i, 1);
        this.selectedLabels.next(copy);
    }
}
/** @nocollapse */ LabelingComponent.ɵfac = function LabelingComponent_Factory(t) { return new (t || LabelingComponent)(i0.ɵɵdirectiveInject(i1$1.FormBuilder), i0.ɵɵdirectiveInject(LabelEditService), i0.ɵɵdirectiveInject(LABEL_ASPECT)); };
/** @nocollapse */ LabelingComponent.ɵcmp = /** @pureOrBreakMyCode */ i0.ɵɵdefineComponent({ type: LabelingComponent, selectors: [["chain-main-labeling"]], inputs: { labelList: "labelList" }, outputs: { labelAdded: "labelAdded", navigateToAllLabels: "navigateToAllLabels" }, features: [i0.ɵɵProvidersFeature([LabelEditService])], decls: 7, vars: 6, consts: [["id", "labelEdit", "fxLayout", "column", "fxLayoutGap", "20px"], [3, "ngStyle", "removed", 4, "ngFor", "ngForOf"], ["fxLayout", "column", "fxLayoutGap", "10px", 4, "ngIf"], [3, "ngStyle", "removed"], ["matChipRemove", ""], ["fxLayout", "column", "fxLayoutGap", "10px"], ["color", "accent"], ["matInput", "", 3, "placeholder"], ["fxFlex", "1 1 20%"], [1, "select-list", 3, "ngModel", "compareWith", "ngModelChange"], ["selectionList", ""], [3, "value", "ngStyle", 4, "ngFor", "ngForOf"], [3, "clickOutside"], [3, "formGroup"], [1, "field-wrap"], ["appearance", "outline"], ["formControlName", "name", "autocomplete", "off", "matInput", "", 3, "ngStyle", "placeholder", "click"], ["class", "field-wrap", 4, "ngIf"], [3, "value", "ngStyle"], ["fxLayout", "row", "fxLayoutAlign", "space-between"], [3, "click"], ["autocomplete", "new-labelinput", "matInput", "", "formControlName", "colorCode"], [3, "cpToggle", "cpDialogDisplay", "cpDisableInput", "colorPicker", "colorPickerChange"], ["mat-button", "", "mat-raised-button", "", 3, "disabled", "click"]], template: function LabelingComponent_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "div", 0)(1, "div")(2, "mat-chip-list");
            i0.ɵɵtemplate(3, LabelingComponent_mat_chip_3_Template, 4, 4, "mat-chip", 1);
            i0.ɵɵpipe(4, "async");
            i0.ɵɵelementEnd()();
            i0.ɵɵtemplate(5, LabelingComponent_div_5_Template, 16, 16, "div", 2);
            i0.ɵɵpipe(6, "async");
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            i0.ɵɵadvance(3);
            i0.ɵɵproperty("ngForOf", i0.ɵɵpipeBind1(4, 2, ctx.selectedLabels));
            i0.ɵɵadvance(2);
            i0.ɵɵproperty("ngIf", i0.ɵɵpipeBind1(6, 4, ctx.labelEditService.labelManagementShown));
        }
    }, dependencies: [i3.ColorPickerDirective, i4.NgForOf, i4.NgIf, i4.NgStyle, i5.MatChipList, i5.MatChip, i5.MatChipRemove, i6.MatSelectionList, i6.MatListOption, i1$1.ɵNgNoValidate, i1$1.DefaultValueAccessor, i1$1.NgControlStatus, i1$1.NgControlStatusGroup, i1$1.NgModel, i1$1.FormGroupDirective, i1$1.FormControlName, i7.MatIcon, i8.MatFormField, i9.MatInput, i10.MatButton, i11.ClickOutsideDirective, i12.DefaultLayoutDirective, i12.DefaultLayoutGapDirective, i12.DefaultLayoutAlignDirective, i12.DefaultFlexDirective, i4.AsyncPipe, i1.TranslatePipe], styles: ["#labelEdit[_ngcontent-%COMP%]   .select-list[_ngcontent-%COMP%]{overflow:auto;height:30vh;overflow-y:scroll}"] });
(function () {
    (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(LabelingComponent, [{
            type: Component,
            args: [{ selector: 'chain-main-labeling', providers: [LabelEditService], template: "<!--TODO Add CSS-->\n<div id=\"labelEdit\" fxLayout=\"column\" fxLayoutGap=\"20px\">\n    <div> <!--show currently selected selectedLabels-->\n        <mat-chip-list>\n            <mat-chip *ngFor=\"let label of selectedLabels | async; let i = index\"\n                      [ngStyle]=\"{'background-color': label.colorCode}\" (removed)=\"removeLabelFromSelection(i)\">\n                {{label.name}}\n                <mat-icon matChipRemove>cancel</mat-icon>\n            </mat-chip>\n        </mat-chip-list>\n\n    </div>\n\n    <div *ngIf=\"labelEditService.labelManagementShown | async\" fxLayout=\"column\" fxLayoutGap=\"10px\">\n        <!--only visible when the edit button is clicked-->\n        <mat-form-field color=\"accent\">\n            <input matInput placeholder=\"{{'CMD.FIND' | translate}}\">\n        </mat-form-field>\n        <!--Label selection list-->\n        <div fxFlex=\"1 1 20%\">\n            <mat-selection-list #selectionList [ngModel]=\"selectedLabels | async\" [compareWith]=\"compareLabels\"\n                                class=\"select-list\"\n                                (ngModelChange)=\"selectedLabels.next($event)\">\n\n                <mat-list-option *ngFor=\"let label of labelList\" [value]=\"label\"\n                                 [ngStyle]=\"{'background-color': label.colorCode}\">\n                    <div fxLayout=\"row\" fxLayoutAlign=\"space-between\">\n                        <div>{{label.name}}</div>\n                        <mat-icon (click)=\"deleteLabel($event,label.id)\">delete</mat-icon>\n                    </div>\n\n                </mat-list-option>\n\n\n            </mat-selection-list>\n        </div>\n\n        <!--add a custom label-->\n        <div (clickOutside)=\"showAddLabelBox=false\">\n            <form [formGroup]=\"newLabel\">\n                <div class=\"field-wrap\">\n                    <mat-form-field appearance=\"outline\">\n                        <input (click)=\"showAddLabelBox=true\" [ngStyle]=\"{'color': newLabel.value.colorCode}\"\n                               formControlName=\"name\"\n                               autocomplete=\"off\"\n                               matInput placeholder=\"{{'LABEL.ADD_NEW' | translate}}\">\n                    </mat-form-field>\n\n                    <!--the options below are shown only when clicking on the ADD_NEW text field-->\n                    <div class=\"field-wrap\" *ngIf=\"showAddLabelBox\">\n                        <input autocomplete=\"new-labelinput\" matInput formControlName=\"colorCode\">\n\n                        <span [style.background]=\"pickedColor\"\n                              [cpToggle]=\"true\"\n                              [cpDialogDisplay]=\"'inline'\"\n                              [cpDisableInput]=\"true\"\n                              [(colorPicker)]=\"pickedColor\"\n                              (colorPickerChange)=\"colorPickerChange($event)\"></span>\n\n\n                        <button [disabled]=\"newLabel.invalid\" mat-button mat-raised-button (click)=\"createNewLabel()\">\n                            {{'CMD.ADD' | translate}}\n                        </button>\n\n                    </div>\n                </div>\n            </form>\n        </div>\n\n    </div>\n</div>\n", styles: ["#labelEdit .select-list{overflow:auto;height:30vh;overflow-y:scroll}\n"] }]
        }], function () {
        return [{ type: i1$1.FormBuilder }, { type: LabelEditService }, { type: undefined, decorators: [{
                        type: Inject,
                        args: [LABEL_ASPECT]
                    }] }];
    }, { labelList: [{
                type: Input
            }], labelAdded: [{
                type: Output
            }], navigateToAllLabels: [{
                type: Output
            }] });
})();

class ChainMainLabel {
}
/** @nocollapse */ ChainMainLabel.ɵfac = function ChainMainLabel_Factory(t) { return new (t || ChainMainLabel)(); };
/** @nocollapse */ ChainMainLabel.ɵmod = /** @pureOrBreakMyCode */ i0.ɵɵdefineNgModule({ type: ChainMainLabel });
/** @nocollapse */ ChainMainLabel.ɵinj = /** @pureOrBreakMyCode */ i0.ɵɵdefineInjector({ imports: [ColorPickerModule,
        //     ClickOutsideModule,
        CommonModule,
        MatChipsModule,
        TranslateModule,
        MatTableModule,
        MatListModule,
        FormsModule,
        ReactiveFormsModule,
        MatIconModule,
        MatSelectModule,
        MatInputModule,
        MatButtonModule,
        ClickOutsideModule,
        FlexModule] });
(function () {
    (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(ChainMainLabel, [{
            type: NgModule,
            args: [{
                    declarations: [
                        LabelTableComponent,
                        LabelingComponent
                    ],
                    imports: [
                        ColorPickerModule,
                        //     ClickOutsideModule,
                        CommonModule,
                        MatChipsModule,
                        TranslateModule,
                        MatTableModule,
                        MatListModule,
                        FormsModule,
                        ReactiveFormsModule,
                        MatIconModule,
                        MatSelectModule,
                        MatInputModule,
                        MatButtonModule,
                        ClickOutsideModule,
                        FlexModule
                    ],
                    exports: [
                        LabelTableComponent,
                        LabelingComponent,
                    ],
                    providers: [],
                    entryComponents: [],
                    schemas: []
                }]
        }], null, null);
})();
(function () {
    (typeof ngJitMode === "undefined" || ngJitMode) && i0.ɵɵsetNgModuleScope(ChainMainLabel, { declarations: [LabelTableComponent,
            LabelingComponent], imports: [ColorPickerModule,
            //     ClickOutsideModule,
            CommonModule,
            MatChipsModule,
            TranslateModule,
            MatTableModule,
            MatListModule,
            FormsModule,
            ReactiveFormsModule,
            MatIconModule,
            MatSelectModule,
            MatInputModule,
            MatButtonModule,
            ClickOutsideModule,
            FlexModule], exports: [LabelTableComponent,
            LabelingComponent] });
})();

class GroupTableQueryStore extends QueryTableSource {
    constructor(service, paginator, sort, tableFilter) {
        super(paginator, sort, tableFilter);
        this.service = service;
        this.paginator = paginator;
        this.sort = sort;
        this.tableFilter = tableFilter;
        this.filterSubject = new BehaviorSubject(tableFilter);
    }
    queryTable() {
        let filter = this.findFilter();
        this.applyFilter(filter);
        if (filter.keyword)
            filter.keyword += '*';
        return this.service.queryGroups(filter);
    }
}

//@Injectable({providedIn: 'root'})
class GroupService extends RestAspect {
    constructor(http, configService) {
        super(http, configService);
        this.http = http;
        this.configService = configService;
    }
    // searchGroups(filter: GroupFilter): Observable<Group> {
    //   return this.http.post<Group>(this.formatServiceUrl('/search'), filter);
    // }
    loadGroup(name) {
        return this.http.get(this.formatServiceUrl('/' + name));
    }
    editGroup(group) {
        return this.http.post(this.formatServiceUrl(), group);
    }
    queryGroups(filter) {
        return this.query(this.formatServiceUrl('/query'), filter);
    }
    deleteGroup(name) {
        return this.http.delete(this.formatServiceUrl('/' + name));
    }
    updateGroup(group) {
        return this.http.put(this.formatServiceUrl(), group);
    }
    createGroup(value) {
        return this.editGroup(value);
    }
    formatServiceUrl(path = '') {
        return this.configService.formatUrl("mainUrl") + "/groups" + path;
    }
}
/** @nocollapse */ GroupService.ɵfac = function GroupService_Factory(t) { return new (t || GroupService)(i0.ɵɵinject(i1$2.HttpClient), i0.ɵɵinject(i2$1.ConfigService)); };
/** @nocollapse */ GroupService.ɵprov = /** @pureOrBreakMyCode */ i0.ɵɵdefineInjectable({ token: GroupService, factory: GroupService.ɵfac });
(function () {
    (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(GroupService, [{
            type: Injectable
        }], function () { return [{ type: i1$2.HttpClient }, { type: i2$1.ConfigService }]; }, null);
})();

const _c0$2 = ["searchField"];
function GroupTableComponent_mat_header_cell_16_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementStart(0, "mat-header-cell", 22);
        i0.ɵɵtext(1);
        i0.ɵɵpipe(2, "translate");
        i0.ɵɵelementEnd();
    }
    if (rf & 2) {
        i0.ɵɵadvance(1);
        i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "GROUPS.NAME"));
    }
}
function GroupTableComponent_mat_cell_17_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementStart(0, "mat-cell")(1, "span");
        i0.ɵɵtext(2);
        i0.ɵɵelementEnd()();
    }
    if (rf & 2) {
        const row_r15 = ctx.$implicit;
        i0.ɵɵadvance(2);
        i0.ɵɵtextInterpolate(row_r15 == null ? null : row_r15.name);
    }
}
function GroupTableComponent_mat_header_cell_19_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementStart(0, "mat-header-cell", 22);
        i0.ɵɵtext(1);
        i0.ɵɵpipe(2, "translate");
        i0.ɵɵelementEnd();
    }
    if (rf & 2) {
        i0.ɵɵadvance(1);
        i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "GROUPS.ORG_ID"));
    }
}
function GroupTableComponent_mat_cell_20_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementStart(0, "mat-cell")(1, "span");
        i0.ɵɵtext(2);
        i0.ɵɵelementEnd()();
    }
    if (rf & 2) {
        const row_r16 = ctx.$implicit;
        i0.ɵɵadvance(2);
        i0.ɵɵtextInterpolate(row_r16 == null ? null : row_r16.orgId);
    }
}
function GroupTableComponent_mat_header_cell_22_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementStart(0, "mat-header-cell", 22);
        i0.ɵɵtext(1);
        i0.ɵɵpipe(2, "translate");
        i0.ɵɵelementEnd();
    }
    if (rf & 2) {
        i0.ɵɵadvance(1);
        i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "GROUPS.TYPE"));
    }
}
function GroupTableComponent_mat_cell_23_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementStart(0, "mat-cell")(1, "span");
        i0.ɵɵtext(2);
        i0.ɵɵelementEnd()();
    }
    if (rf & 2) {
        const row_r17 = ctx.$implicit;
        i0.ɵɵadvance(2);
        i0.ɵɵtextInterpolate(row_r17 == null ? null : row_r17.type);
    }
}
function GroupTableComponent_mat_header_cell_25_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementStart(0, "mat-header-cell", 22);
        i0.ɵɵtext(1);
        i0.ɵɵpipe(2, "translate");
        i0.ɵɵelementEnd();
    }
    if (rf & 2) {
        i0.ɵɵadvance(1);
        i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "GROUPS.NAME"));
    }
}
function GroupTableComponent_mat_cell_26_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementStart(0, "mat-cell", 23)(1, "span");
        i0.ɵɵtext(2);
        i0.ɵɵelementEnd()();
    }
    if (rf & 2) {
        const row_r18 = ctx.$implicit;
        i0.ɵɵproperty("matTooltip", row_r18.info.desc || row_r18.name);
        i0.ɵɵadvance(2);
        i0.ɵɵtextInterpolate(row_r18 == null ? null : row_r18.info == null ? null : row_r18.info.name);
    }
}
function GroupTableComponent_mat_header_cell_28_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementStart(0, "mat-header-cell");
        i0.ɵɵtext(1);
        i0.ɵɵpipe(2, "translate");
        i0.ɵɵelementEnd();
    }
    if (rf & 2) {
        i0.ɵɵadvance(1);
        i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "GROUPS.ROLES"));
    }
}
function GroupTableComponent_mat_cell_29_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementStart(0, "mat-cell")(1, "span");
        i0.ɵɵtext(2);
        i0.ɵɵelementEnd()();
    }
    if (rf & 2) {
        const row_r19 = ctx.$implicit;
        i0.ɵɵadvance(2);
        i0.ɵɵtextInterpolate(row_r19 == null ? null : row_r19.roles.join(" , "));
    }
}
function GroupTableComponent_mat_header_row_30_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelement(0, "mat-header-row");
    }
}
function GroupTableComponent_mat_row_31_Template(rf, ctx) {
    if (rf & 1) {
        const _r22 = i0.ɵɵgetCurrentView();
        i0.ɵɵelementStart(0, "mat-row", 24);
        i0.ɵɵlistener("click", function GroupTableComponent_mat_row_31_Template_mat_row_click_0_listener() { const restoredCtx = i0.ɵɵrestoreView(_r22); const row_r20 = restoredCtx.$implicit; const ctx_r21 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r21.onAction("select", row_r20)); });
        i0.ɵɵelementEnd();
    }
}
const _c1$2 = function () { return [5, 10, 25, 100]; };
const _c2$2 = ["*"];
const TAG$2 = 'GroupTableComponent';
class GroupTableComponent {
    constructor(_service) {
        this._service = _service;
        this.displayedColumns = ['info.name', 'roles'];
        this.filter = {};
        this.showToolbar = true;
        this.action = new EventEmitter();
    }
    ngOnInit() {
        let filter = this.filter;
        if (!this.dataSource) {
            this.dataSource = new GroupTableQueryStore(this._service, this.paginator, this.sort, filter);
        }
        console.log(TAG$2, "nativeElement", this.searchElem);
        if (this.searchElem) {
            fromEvent(this.searchElem.nativeElement, 'keyup')
                .pipe(debounceTime(1000), distinctUntilChanged())
                .subscribe(event => {
                let value = this.searchElem.nativeElement.value;
                if (value == '')
                    value = null;
                // let filter = this.dataSource.filterSubject.value;
                let filter = this.filter;
                filter.keyword = value;
                console.log(TAG$2, "nativeElement change", value);
                this.reload();
            });
        }
    }
    reload() {
        this.dataSource.reload();
    }
    onAction(type, payload) {
        this.action.emit({ type: type, value: payload });
    }
}
/** @nocollapse */ GroupTableComponent.ɵfac = function GroupTableComponent_Factory(t) { return new (t || GroupTableComponent)(i0.ɵɵdirectiveInject(GroupService)); };
/** @nocollapse */ GroupTableComponent.ɵcmp = /** @pureOrBreakMyCode */ i0.ɵɵdefineComponent({ type: GroupTableComponent, selectors: [["main-group-table"]], viewQuery: function GroupTableComponent_Query(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵviewQuery(MatPaginator, 7);
            i0.ɵɵviewQuery(MatSort, 7);
            i0.ɵɵviewQuery(_c0$2, 7);
        }
        if (rf & 2) {
            let _t;
            i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.paginator = _t.first);
            i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.sort = _t.first);
            i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.searchElem = _t.first);
        }
    }, inputs: { displayedColumns: "displayedColumns", filter: "filter", dataSource: "dataSource", showToolbar: "showToolbar" }, outputs: { action: "action" }, ngContentSelectors: _c2$2, decls: 32, vars: 7, consts: [[1, "table-layout-1", "group-table-layout"], ["fxLayoutAlign", "space-between center", 1, "primary-300--bg"], [3, "pageIndex", "pageSize", "pageSizeOptions"], ["paginator", ""], [1, "field-wrap"], [1, "field-box", "trans-icon"], ["type", "text"], ["searchField", ""], ["type", "button", 3, "click"], ["matSort", "", "matSortActive", "info.name", "matSortDirection", "asc", "matSortDisableClear", "", 1, "table-hover-1", 3, "dataSource"], ["table", ""], ["matColumnDef", "name"], ["mat-sort-header", "", 4, "matHeaderCellDef"], [4, "matCellDef"], ["matColumnDef", "orgId"], ["matColumnDef", "type"], ["matColumnDef", "info.name"], [3, "matTooltip", 4, "matCellDef"], ["matColumnDef", "roles"], [4, "matHeaderCellDef"], [4, "matHeaderRowDef"], [3, "click", 4, "matRowDef", "matRowDefColumns"], ["mat-sort-header", ""], [3, "matTooltip"], [3, "click"]], template: function GroupTableComponent_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵprojectionDef();
            i0.ɵɵelementStart(0, "div", 0);
            i0.ɵɵprojection(1);
            i0.ɵɵelementStart(2, "mat-toolbar", 1);
            i0.ɵɵelement(3, "mat-paginator", 2, 3);
            i0.ɵɵelementStart(5, "div", 4)(6, "div", 5);
            i0.ɵɵelement(7, "input", 6, 7);
            i0.ɵɵelementStart(9, "button", 8);
            i0.ɵɵlistener("click", function GroupTableComponent_Template_button_click_9_listener() { return ctx.reload(); });
            i0.ɵɵelementStart(10, "i")(11, "mat-icon");
            i0.ɵɵtext(12, "search");
            i0.ɵɵelementEnd()()()()()();
            i0.ɵɵelementStart(13, "mat-table", 9, 10);
            i0.ɵɵelementContainerStart(15, 11);
            i0.ɵɵtemplate(16, GroupTableComponent_mat_header_cell_16_Template, 3, 3, "mat-header-cell", 12);
            i0.ɵɵtemplate(17, GroupTableComponent_mat_cell_17_Template, 3, 1, "mat-cell", 13);
            i0.ɵɵelementContainerEnd();
            i0.ɵɵelementContainerStart(18, 14);
            i0.ɵɵtemplate(19, GroupTableComponent_mat_header_cell_19_Template, 3, 3, "mat-header-cell", 12);
            i0.ɵɵtemplate(20, GroupTableComponent_mat_cell_20_Template, 3, 1, "mat-cell", 13);
            i0.ɵɵelementContainerEnd();
            i0.ɵɵelementContainerStart(21, 15);
            i0.ɵɵtemplate(22, GroupTableComponent_mat_header_cell_22_Template, 3, 3, "mat-header-cell", 12);
            i0.ɵɵtemplate(23, GroupTableComponent_mat_cell_23_Template, 3, 1, "mat-cell", 13);
            i0.ɵɵelementContainerEnd();
            i0.ɵɵelementContainerStart(24, 16);
            i0.ɵɵtemplate(25, GroupTableComponent_mat_header_cell_25_Template, 3, 3, "mat-header-cell", 12);
            i0.ɵɵtemplate(26, GroupTableComponent_mat_cell_26_Template, 3, 2, "mat-cell", 17);
            i0.ɵɵelementContainerEnd();
            i0.ɵɵelementContainerStart(27, 18);
            i0.ɵɵtemplate(28, GroupTableComponent_mat_header_cell_28_Template, 3, 3, "mat-header-cell", 19);
            i0.ɵɵtemplate(29, GroupTableComponent_mat_cell_29_Template, 3, 1, "mat-cell", 13);
            i0.ɵɵelementContainerEnd();
            i0.ɵɵtemplate(30, GroupTableComponent_mat_header_row_30_Template, 1, 0, "mat-header-row", 20);
            i0.ɵɵtemplate(31, GroupTableComponent_mat_row_31_Template, 1, 0, "mat-row", 21);
            i0.ɵɵelementEnd()();
        }
        if (rf & 2) {
            i0.ɵɵadvance(3);
            i0.ɵɵproperty("pageIndex", 0)("pageSize", 10)("pageSizeOptions", i0.ɵɵpureFunction0(6, _c1$2));
            i0.ɵɵadvance(10);
            i0.ɵɵproperty("dataSource", ctx.dataSource);
            i0.ɵɵadvance(17);
            i0.ɵɵproperty("matHeaderRowDef", ctx.displayedColumns);
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("matRowDefColumns", ctx.displayedColumns);
        }
    }, dependencies: [i2.MatTable, i2.MatHeaderCellDef, i2.MatHeaderRowDef, i2.MatColumnDef, i2.MatCellDef, i2.MatRowDef, i2.MatHeaderCell, i2.MatCell, i2.MatHeaderRow, i2.MatRow, i3$1.MatTooltip, i4$1.MatPaginator, i5$1.MatSort, i5$1.MatSortHeader, i6$1.MatToolbar, i7.MatIcon, i12.DefaultLayoutAlignDirective, i1.TranslatePipe], encapsulation: 2 });
(function () {
    (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(GroupTableComponent, [{
            type: Component,
            args: [{ selector: 'main-group-table', template: "<div class=\"table-layout-1 group-table-layout\">\n\n    <ng-content></ng-content>\n\n  <mat-toolbar class=\"primary-300--bg\" fxLayoutAlign=\"space-between center\">\n    <mat-paginator #paginator [pageIndex]=\"0\" [pageSize]=\"10\" [pageSizeOptions]=\"[5, 10, 25, 100]\">\n    </mat-paginator>\n    <div class=\"field-wrap\">\n      <div class=\"field-box trans-icon\">\n        <input #searchField type=\"text\"/>\n        <button (click)=\"reload()\" type=\"button\">\n          <i><mat-icon>search</mat-icon></i>\n        </button>\n      </div>\n    </div>\n  </mat-toolbar>\n\n  <mat-table class=\"table-hover-1\" #table [dataSource]=\"dataSource\" matSort\n             matSortActive=\"info.name\"\n             matSortDirection=\"asc\"\n             matSortDisableClear>\n\n    <ng-container matColumnDef=\"name\">\n      <mat-header-cell mat-sort-header *matHeaderCellDef>{{'GROUPS.NAME' | translate}}</mat-header-cell>\n      <mat-cell *matCellDef=\"let row\">\n        <span>{{row?.name}}</span></mat-cell>\n    </ng-container>\n\n    <ng-container matColumnDef=\"orgId\">\n      <mat-header-cell mat-sort-header *matHeaderCellDef>{{'GROUPS.ORG_ID' | translate}}</mat-header-cell>\n      <mat-cell *matCellDef=\"let row\">\n        <span>{{row?.orgId}}</span></mat-cell>\n    </ng-container>\n\n    <ng-container matColumnDef=\"type\">\n      <mat-header-cell mat-sort-header *matHeaderCellDef>{{'GROUPS.TYPE' | translate}}</mat-header-cell>\n      <mat-cell *matCellDef=\"let row\">\n        <span>{{row?.type}}</span></mat-cell>\n    </ng-container>\n\n    <ng-container  matColumnDef=\"info.name\">\n      <mat-header-cell mat-sort-header *matHeaderCellDef>{{'GROUPS.NAME' | translate}}</mat-header-cell>\n      <mat-cell *matCellDef=\"let row\" [matTooltip]=\"row.info.desc||row.name\">\n        <span>{{row?.info?.name}}</span></mat-cell>\n    </ng-container>\n\n    <ng-container matColumnDef=\"roles\">\n      <mat-header-cell *matHeaderCellDef>{{'GROUPS.ROLES' | translate}}</mat-header-cell>\n      <mat-cell *matCellDef=\"let row\">\n        <span>{{row?.roles.join(\" , \")}}</span></mat-cell>\n    </ng-container>\n\n    <mat-header-row *matHeaderRowDef=\"displayedColumns\"></mat-header-row>\n    <mat-row *matRowDef=\"let row; columns: displayedColumns;\" (click)=\"onAction('select', row)\">\n    </mat-row>\n\n  </mat-table>\n\n</div>\n\n\n\n" }]
        }], function () { return [{ type: GroupService }]; }, { displayedColumns: [{
                type: Input
            }], filter: [{
                type: Input
            }], dataSource: [{
                type: Input
            }], showToolbar: [{
                type: Input
            }], action: [{
                type: Output
            }], paginator: [{
                type: ViewChild,
                args: [MatPaginator, { static: true }]
            }], sort: [{
                type: ViewChild,
                args: [MatSort, { static: true }]
            }], searchElem: [{
                type: ViewChild,
                args: ['searchField', { static: true }]
            }] });
})();

class MainGroupModule {
}
/** @nocollapse */ MainGroupModule.ɵfac = function MainGroupModule_Factory(t) { return new (t || MainGroupModule)(); };
/** @nocollapse */ MainGroupModule.ɵmod = /** @pureOrBreakMyCode */ i0.ɵɵdefineNgModule({ type: MainGroupModule });
/** @nocollapse */ MainGroupModule.ɵinj = /** @pureOrBreakMyCode */ i0.ɵɵdefineInjector({ imports: [CommonModule,
        TranslateModule.forChild({}),
        ReactiveFormsModule,
        MatCardModule,
        MatTableModule,
        MatTooltipModule,
        MatPaginatorModule,
        MatSortModule,
        MatToolbarModule,
        MatButtonModule,
        MatIconModule,
        FlexLayoutModule,
        FormsModule,
        ChainBaseComp] });
(function () {
    (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MainGroupModule, [{
            type: NgModule,
            args: [{
                    imports: [
                        CommonModule,
                        TranslateModule.forChild({}),
                        ReactiveFormsModule,
                        MatCardModule,
                        MatTableModule,
                        MatTooltipModule,
                        MatPaginatorModule,
                        MatSortModule,
                        MatToolbarModule,
                        MatButtonModule,
                        MatIconModule,
                        FlexLayoutModule,
                        FormsModule,
                        ChainBaseComp
                    ],
                    declarations: [
                        GroupTableComponent
                    ],
                    exports: [
                        GroupTableComponent
                    ]
                }]
        }], null, null);
})();
(function () {
    (typeof ngJitMode === "undefined" || ngJitMode) && i0.ɵɵsetNgModuleScope(MainGroupModule, { declarations: [GroupTableComponent], imports: [CommonModule, i1.TranslateModule, ReactiveFormsModule,
            MatCardModule,
            MatTableModule,
            MatTooltipModule,
            MatPaginatorModule,
            MatSortModule,
            MatToolbarModule,
            MatButtonModule,
            MatIconModule,
            FlexLayoutModule,
            FormsModule,
            ChainBaseComp], exports: [GroupTableComponent] });
})();

class UserQueryStore extends QueryTableSource {
    constructor(service, paginator, sort, tableFilter) {
        super(paginator, sort, tableFilter);
        this.service = service;
        this.paginator = paginator;
        this.sort = sort;
        this.tableFilter = tableFilter;
        this.filterSubject = new BehaviorSubject(tableFilter);
    }
    queryTable() {
        let filter = this.findFilter();
        this.applyFilter(filter);
        if (filter.keyword)
            filter.keyword += '*';
        return this.service.queryUser(filter);
    }
}

// @Injectable({
//     providedIn: 'root'
// })
class UserService extends RestAspect {
    //Users: User[];
    constructor(http, configService) {
        super(http, configService);
        this.http = http;
        this.configService = configService;
    }
    /** @deprecated */
    searchUser(filter) {
        return this.search(this.formatServiceUrl('/user'), filter);
    }
    queryUser(filter) {
        return this.query(this.formatServiceUrl('/query'), filter);
    }
    loadUser(id) {
        //return this.load<User>(`${this.formatServiceUrl('')}${id}`)
        return this.load(this.formatServiceUrl(`/${id}`))
            .pipe(map(value => this.checkNotNull(value)));
    }
    saveUser(user, method) {
        return this.edit(this.formatServiceUrl(), user, { method: method });
    }
    deleteUser(username) {
        return this.http.delete(this.formatServiceUrl(`/${username}`));
    }
    formatServiceUrl(path = '') {
        return this.configService.formatUrl("mainUrl") + "/users" + path;
    }
}
/** @nocollapse */ UserService.ɵfac = function UserService_Factory(t) { return new (t || UserService)(i0.ɵɵinject(i1$2.HttpClient), i0.ɵɵinject(i2$1.ConfigService)); };
/** @nocollapse */ UserService.ɵprov = /** @pureOrBreakMyCode */ i0.ɵɵdefineInjectable({ token: UserService, factory: UserService.ɵfac });
(function () {
    (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(UserService, [{
            type: Injectable
        }], function () { return [{ type: i1$2.HttpClient }, { type: i2$1.ConfigService }]; }, null);
})();

const _c0$1 = ["searchField"];
function UserTableComponent_mat_header_cell_16_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementStart(0, "mat-header-cell", 20);
        i0.ɵɵtext(1);
        i0.ɵɵpipe(2, "translate");
        i0.ɵɵelementEnd();
    }
    if (rf & 2) {
        i0.ɵɵadvance(1);
        i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "USER.HEADER.USER_NAME"));
    }
}
function UserTableComponent_mat_cell_17_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementStart(0, "mat-cell")(1, "span");
        i0.ɵɵtext(2);
        i0.ɵɵelementEnd()();
    }
    if (rf & 2) {
        const row_r15 = ctx.$implicit;
        i0.ɵɵadvance(2);
        i0.ɵɵtextInterpolate(row_r15.username);
    }
}
function UserTableComponent_mat_header_cell_19_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementStart(0, "mat-header-cell", 20);
        i0.ɵɵtext(1);
        i0.ɵɵpipe(2, "translate");
        i0.ɵɵelementEnd();
    }
    if (rf & 2) {
        i0.ɵɵadvance(1);
        i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "USER.HEADER.FIRST_NAME"));
    }
}
function UserTableComponent_mat_cell_20_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementStart(0, "mat-cell")(1, "span");
        i0.ɵɵtext(2);
        i0.ɵɵelementEnd()();
    }
    if (rf & 2) {
        const row_r16 = ctx.$implicit;
        i0.ɵɵadvance(2);
        i0.ɵɵtextInterpolate(row_r16.person == null ? null : row_r16.person.firstName);
    }
}
function UserTableComponent_mat_header_cell_22_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementStart(0, "mat-header-cell", 20);
        i0.ɵɵtext(1);
        i0.ɵɵpipe(2, "translate");
        i0.ɵɵelementEnd();
    }
    if (rf & 2) {
        i0.ɵɵadvance(1);
        i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "USER.HEADER.LAST_NAME"));
    }
}
function UserTableComponent_mat_cell_23_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementStart(0, "mat-cell")(1, "span");
        i0.ɵɵtext(2);
        i0.ɵɵelementEnd()();
    }
    if (rf & 2) {
        const row_r17 = ctx.$implicit;
        i0.ɵɵadvance(2);
        i0.ɵɵtextInterpolate(row_r17.person == null ? null : row_r17.person.lastName);
    }
}
function UserTableComponent_mat_header_cell_25_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementStart(0, "mat-header-cell", 20);
        i0.ɵɵtext(1);
        i0.ɵɵpipe(2, "translate");
        i0.ɵɵelementEnd();
    }
    if (rf & 2) {
        i0.ɵɵadvance(1);
        i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "USER.HEADER.GROUPS"));
    }
}
function UserTableComponent_mat_cell_26_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementStart(0, "mat-cell")(1, "span");
        i0.ɵɵtext(2);
        i0.ɵɵelementEnd()();
    }
    if (rf & 2) {
        const row_r18 = ctx.$implicit;
        i0.ɵɵadvance(2);
        i0.ɵɵtextInterpolate(row_r18.groups);
    }
}
function UserTableComponent_mat_header_cell_28_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementStart(0, "mat-header-cell", 20);
        i0.ɵɵtext(1);
        i0.ɵɵpipe(2, "translate");
        i0.ɵɵelementEnd();
    }
    if (rf & 2) {
        i0.ɵɵadvance(1);
        i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "USER.HEADER.CREATED_DATE"));
    }
}
function UserTableComponent_mat_cell_29_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementStart(0, "mat-cell")(1, "span");
        i0.ɵɵtext(2);
        i0.ɵɵpipe(3, "date");
        i0.ɵɵelementEnd()();
    }
    if (rf & 2) {
        const row_r19 = ctx.$implicit;
        i0.ɵɵadvance(2);
        i0.ɵɵtextInterpolate(i0.ɵɵpipeBind2(3, 1, row_r19.created == null ? null : row_r19.created.date, "shortDate"));
    }
}
function UserTableComponent_mat_header_row_30_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelement(0, "mat-header-row");
    }
}
function UserTableComponent_mat_row_31_Template(rf, ctx) {
    if (rf & 1) {
        const _r22 = i0.ɵɵgetCurrentView();
        i0.ɵɵelementStart(0, "mat-row", 21);
        i0.ɵɵlistener("click", function UserTableComponent_mat_row_31_Template_mat_row_click_0_listener() { const restoredCtx = i0.ɵɵrestoreView(_r22); const row_r20 = restoredCtx.$implicit; const ctx_r21 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r21.onAction("select", row_r20)); });
        i0.ɵɵelementEnd();
    }
}
const _c1$1 = function () { return [5, 10, 25, 100]; };
const _c2$1 = ["*"];
const TAG$1 = 'UserTableComponent';
class UserTableComponent {
    constructor(_service) {
        this._service = _service;
        this.displayedColumns = ['username', 'person.firstName', 'person.lastName', 'created.date'];
        this.filter = {};
        this.showToolbar = true;
        this.action = new EventEmitter();
    }
    ngOnInit() {
        let filter = this.filter;
        if (!this.dataSource) {
            this.dataSource = new UserQueryStore(this._service, this.paginator, this.sort, filter);
        }
        if (this.searchElem) {
            fromEvent(this.searchElem.nativeElement, 'keyup')
                .pipe(debounceTime(1000), distinctUntilChanged())
                .subscribe(event => {
                let value = this.searchElem.nativeElement.value;
                if (value == '')
                    value = null;
                // let filter = this.dataSource.filterSubject.value;
                let filter = this.filter;
                filter.keyword = value;
                this.reload();
            });
        }
    }
    reload() {
        this.dataSource.reload();
    }
    onAction(type, payload) {
        this.action.emit({ type: type, value: payload });
    }
}
/** @nocollapse */ UserTableComponent.ɵfac = function UserTableComponent_Factory(t) { return new (t || UserTableComponent)(i0.ɵɵdirectiveInject(UserService)); };
/** @nocollapse */ UserTableComponent.ɵcmp = /** @pureOrBreakMyCode */ i0.ɵɵdefineComponent({ type: UserTableComponent, selectors: [["main-user-table"]], viewQuery: function UserTableComponent_Query(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵviewQuery(MatPaginator, 7);
            i0.ɵɵviewQuery(MatSort, 7);
            i0.ɵɵviewQuery(_c0$1, 7);
        }
        if (rf & 2) {
            let _t;
            i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.paginator = _t.first);
            i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.sort = _t.first);
            i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.searchElem = _t.first);
        }
    }, inputs: { displayedColumns: "displayedColumns", filter: "filter", dataSource: "dataSource", showToolbar: "showToolbar" }, outputs: { action: "action" }, ngContentSelectors: _c2$1, decls: 32, vars: 7, consts: [[1, "table-layout-1", "user-table-layout"], ["fxLayoutAlign", "space-between center", 1, "primary-300-bg"], [3, "pageIndex", "pageSize", "pageSizeOptions"], ["paginator", ""], [1, "field-wrap"], [1, "field-box", "trans-icon"], ["type", "text"], ["searchField", ""], ["type", "button", 3, "click"], ["matSort", "", "matSortActive", "created.date", "matSortDirection", "desc", "matSortDisableClear", "", 1, "table-hover-1", 3, "dataSource"], ["table", ""], ["matColumnDef", "username"], ["mat-sort-header", "", 4, "matHeaderCellDef"], [4, "matCellDef"], ["matColumnDef", "person.firstName"], ["matColumnDef", "person.lastName"], ["matColumnDef", "groups"], ["matColumnDef", "created.date"], [4, "matHeaderRowDef"], [3, "click", 4, "matRowDef", "matRowDefColumns"], ["mat-sort-header", ""], [3, "click"]], template: function UserTableComponent_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵprojectionDef();
            i0.ɵɵelementStart(0, "div", 0);
            i0.ɵɵprojection(1);
            i0.ɵɵelementStart(2, "mat-toolbar", 1);
            i0.ɵɵelement(3, "mat-paginator", 2, 3);
            i0.ɵɵelementStart(5, "div", 4)(6, "div", 5);
            i0.ɵɵelement(7, "input", 6, 7);
            i0.ɵɵelementStart(9, "button", 8);
            i0.ɵɵlistener("click", function UserTableComponent_Template_button_click_9_listener() { return ctx.reload(); });
            i0.ɵɵelementStart(10, "i")(11, "mat-icon");
            i0.ɵɵtext(12, "search");
            i0.ɵɵelementEnd()()()()()();
            i0.ɵɵelementStart(13, "mat-table", 9, 10);
            i0.ɵɵelementContainerStart(15, 11);
            i0.ɵɵtemplate(16, UserTableComponent_mat_header_cell_16_Template, 3, 3, "mat-header-cell", 12);
            i0.ɵɵtemplate(17, UserTableComponent_mat_cell_17_Template, 3, 1, "mat-cell", 13);
            i0.ɵɵelementContainerEnd();
            i0.ɵɵelementContainerStart(18, 14);
            i0.ɵɵtemplate(19, UserTableComponent_mat_header_cell_19_Template, 3, 3, "mat-header-cell", 12);
            i0.ɵɵtemplate(20, UserTableComponent_mat_cell_20_Template, 3, 1, "mat-cell", 13);
            i0.ɵɵelementContainerEnd();
            i0.ɵɵelementContainerStart(21, 15);
            i0.ɵɵtemplate(22, UserTableComponent_mat_header_cell_22_Template, 3, 3, "mat-header-cell", 12);
            i0.ɵɵtemplate(23, UserTableComponent_mat_cell_23_Template, 3, 1, "mat-cell", 13);
            i0.ɵɵelementContainerEnd();
            i0.ɵɵelementContainerStart(24, 16);
            i0.ɵɵtemplate(25, UserTableComponent_mat_header_cell_25_Template, 3, 3, "mat-header-cell", 12);
            i0.ɵɵtemplate(26, UserTableComponent_mat_cell_26_Template, 3, 1, "mat-cell", 13);
            i0.ɵɵelementContainerEnd();
            i0.ɵɵelementContainerStart(27, 17);
            i0.ɵɵtemplate(28, UserTableComponent_mat_header_cell_28_Template, 3, 3, "mat-header-cell", 12);
            i0.ɵɵtemplate(29, UserTableComponent_mat_cell_29_Template, 4, 4, "mat-cell", 13);
            i0.ɵɵelementContainerEnd();
            i0.ɵɵtemplate(30, UserTableComponent_mat_header_row_30_Template, 1, 0, "mat-header-row", 18);
            i0.ɵɵtemplate(31, UserTableComponent_mat_row_31_Template, 1, 0, "mat-row", 19);
            i0.ɵɵelementEnd()();
        }
        if (rf & 2) {
            i0.ɵɵadvance(3);
            i0.ɵɵproperty("pageIndex", 0)("pageSize", 10)("pageSizeOptions", i0.ɵɵpureFunction0(6, _c1$1));
            i0.ɵɵadvance(10);
            i0.ɵɵproperty("dataSource", ctx.dataSource);
            i0.ɵɵadvance(17);
            i0.ɵɵproperty("matHeaderRowDef", ctx.displayedColumns);
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("matRowDefColumns", ctx.displayedColumns);
        }
    }, dependencies: [i2.MatTable, i2.MatHeaderCellDef, i2.MatHeaderRowDef, i2.MatColumnDef, i2.MatCellDef, i2.MatRowDef, i2.MatHeaderCell, i2.MatCell, i2.MatHeaderRow, i2.MatRow, i4$1.MatPaginator, i5$1.MatSort, i5$1.MatSortHeader, i6$1.MatToolbar, i7.MatIcon, i12.DefaultLayoutAlignDirective, i4.DatePipe, i1.TranslatePipe], encapsulation: 2 });
(function () {
    (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(UserTableComponent, [{
            type: Component,
            args: [{ selector: 'main-user-table', template: "<div class=\"table-layout-1 user-table-layout\">\n\n    <ng-content></ng-content>\n\n  <mat-toolbar class=\"primary-300-bg\" fxLayoutAlign=\"space-between center\">\n    <mat-paginator #paginator [pageIndex]=\"0\" [pageSize]=\"10\" [pageSizeOptions]=\"[5, 10, 25, 100]\">\n    </mat-paginator>\n    <div class=\"field-wrap\">\n      <div class=\"field-box trans-icon\">\n        <input #searchField type=\"text\"/>\n        <button (click)=\"reload()\" type=\"button\">\n          <i><mat-icon>search</mat-icon></i>\n        </button>\n      </div>\n    </div>\n  </mat-toolbar>\n\n  <mat-table class=\"table-hover-1\" #table [dataSource]=\"dataSource\" matSort\n             matSortActive=\"created.date\"\n             matSortDirection=\"desc\"\n             matSortDisableClear>\n\n      <!-- username Column -->\n      <ng-container matColumnDef=\"username\">\n          <mat-header-cell mat-sort-header\n                           *matHeaderCellDef>{{'USER.HEADER.USER_NAME' | translate}}</mat-header-cell>\n          <mat-cell *matCellDef=\"let row\"><span>{{row.username}}</span></mat-cell>\n      </ng-container>\n      <!-- firstName Column -->\n      <ng-container matColumnDef=\"person.firstName\">\n          <mat-header-cell mat-sort-header\n                           *matHeaderCellDef>{{'USER.HEADER.FIRST_NAME' | translate}}</mat-header-cell>\n          <mat-cell *matCellDef=\"let row\"><span>{{row.person?.firstName}}</span></mat-cell>\n      </ng-container>\n\n      <!-- lastName Column -->\n      <ng-container matColumnDef=\"person.lastName\">\n          <mat-header-cell mat-sort-header\n                           *matHeaderCellDef>{{'USER.HEADER.LAST_NAME' | translate}}</mat-header-cell>\n          <mat-cell *matCellDef=\"let row\"><span>{{row.person?.lastName}}</span></mat-cell>\n      </ng-container>\n      <!-- groups Column -->\n      <ng-container matColumnDef=\"groups\">\n          <mat-header-cell mat-sort-header\n                           *matHeaderCellDef>{{'USER.HEADER.GROUPS' | translate}}</mat-header-cell>\n          <mat-cell *matCellDef=\"let row\"><span>{{row.groups}}</span></mat-cell>\n      </ng-container>\n\n      <!-- created date Column -->\n      <ng-container matColumnDef=\"created.date\">\n          <mat-header-cell mat-sort-header *matHeaderCellDef>{{'USER.HEADER.CREATED_DATE' | translate}}</mat-header-cell>\n          <mat-cell *matCellDef=\"let row\"><span>{{row.created?.date | date:'shortDate'}}</span></mat-cell>\n      </ng-container>\n\n\n      <mat-header-row *matHeaderRowDef=\"displayedColumns\"></mat-header-row>\n    <mat-row *matRowDef=\"let row; columns: displayedColumns;\" (click)=\"onAction('select', row)\">\n    </mat-row>\n\n  </mat-table>\n\n</div>\n\n\n\n" }]
        }], function () { return [{ type: UserService }]; }, { displayedColumns: [{
                type: Input
            }], filter: [{
                type: Input
            }], dataSource: [{
                type: Input
            }], showToolbar: [{
                type: Input
            }], action: [{
                type: Output
            }], paginator: [{
                type: ViewChild,
                args: [MatPaginator, { static: true }]
            }], sort: [{
                type: ViewChild,
                args: [MatSort, { static: true }]
            }], searchElem: [{
                type: ViewChild,
                args: ['searchField', { static: true }]
            }] });
})();

class MainUserModule {
}
/** @nocollapse */ MainUserModule.ɵfac = function MainUserModule_Factory(t) { return new (t || MainUserModule)(); };
/** @nocollapse */ MainUserModule.ɵmod = /** @pureOrBreakMyCode */ i0.ɵɵdefineNgModule({ type: MainUserModule });
/** @nocollapse */ MainUserModule.ɵinj = /** @pureOrBreakMyCode */ i0.ɵɵdefineInjector({ imports: [CommonModule,
        TranslateModule.forChild({}),
        ReactiveFormsModule,
        MatCardModule,
        MatTableModule,
        MatTooltipModule,
        MatPaginatorModule,
        MatSortModule,
        MatToolbarModule,
        MatButtonModule,
        MatIconModule,
        FlexLayoutModule,
        FormsModule,
        ChainBaseComp] });
(function () {
    (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MainUserModule, [{
            type: NgModule,
            args: [{
                    imports: [
                        CommonModule,
                        TranslateModule.forChild({}),
                        ReactiveFormsModule,
                        MatCardModule,
                        MatTableModule,
                        MatTooltipModule,
                        MatPaginatorModule,
                        MatSortModule,
                        MatToolbarModule,
                        MatButtonModule,
                        MatIconModule,
                        FlexLayoutModule,
                        FormsModule,
                        ChainBaseComp
                    ],
                    declarations: [
                        UserTableComponent
                    ],
                    exports: [
                        UserTableComponent
                    ]
                }]
        }], null, null);
})();
(function () {
    (typeof ngJitMode === "undefined" || ngJitMode) && i0.ɵɵsetNgModuleScope(MainUserModule, { declarations: [UserTableComponent], imports: [CommonModule, i1.TranslateModule, ReactiveFormsModule,
            MatCardModule,
            MatTableModule,
            MatTooltipModule,
            MatPaginatorModule,
            MatSortModule,
            MatToolbarModule,
            MatButtonModule,
            MatIconModule,
            FlexLayoutModule,
            FormsModule,
            ChainBaseComp], exports: [UserTableComponent] });
})();

class SettingQueryStore extends QueryTableSource {
    constructor(service, paginator, sort, tableFilter) {
        super(paginator, sort, tableFilter);
        this.service = service;
        this.paginator = paginator;
        this.sort = sort;
        this.tableFilter = tableFilter;
        this.filterSubject = new BehaviorSubject(tableFilter);
    }
    queryTable() {
        let filter = this.findFilter();
        this.applyFilter(filter);
        if (filter.keyword)
            filter.keyword += '*';
        return this.service.querySettings(filter);
    }
}

class SettingService extends RestAspect {
    constructor(http, configService) {
        super(http, configService);
        this.http = http;
        this.configService = configService;
    }
    // /** @deprecated */
    // searchSettings(filter:SettingFilter): Observable<SearchResult<Setting>> {
    //     return this.search<Setting>(this.formatServiceUrl('settings'),filter);
    // }
    querySettings(filter) {
        return this.query(this.formatServiceUrl('/query'), filter);
    }
    loadSetting(module, shortName) {
        return this.load(`${this.formatServiceUrl()}/${module}/${shortName}`)
            .pipe(map(value => this.checkNotNull(value)));
    }
    loadByKey(key) {
        return this.load(`${this.formatServiceUrl()}/load?key=${key}`)
            .pipe(map(value => this.checkNotNull(value)));
    }
    editSetting(setting) {
        return this.edit(this.formatServiceUrl(), setting, { method: 'put' });
    }
    deleteSetting(module, shortName) {
        return this.http.delete(`${this.formatServiceUrl()}/${module}/${shortName}`);
    }
    formatServiceUrl(path = '') {
        return this.configService.formatUrl("mainUrl") + "/settings" + path;
    }
}
/** @nocollapse */ SettingService.ɵfac = function SettingService_Factory(t) { return new (t || SettingService)(i0.ɵɵinject(i1$2.HttpClient), i0.ɵɵinject(i2$1.ConfigService)); };
/** @nocollapse */ SettingService.ɵprov = /** @pureOrBreakMyCode */ i0.ɵɵdefineInjectable({ token: SettingService, factory: SettingService.ɵfac });
(function () {
    (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SettingService, [{
            type: Injectable
        }], function () { return [{ type: i1$2.HttpClient }, { type: i2$1.ConfigService }]; }, null);
})();

const _c0 = ["searchField"];
const _c1 = function () { return [5, 10, 25, 100]; };
function SettingTableComponent_mat_toolbar_2_Template(rf, ctx) {
    if (rf & 1) {
        const _r21 = i0.ɵɵgetCurrentView();
        i0.ɵɵelementStart(0, "mat-toolbar", 15);
        i0.ɵɵelement(1, "mat-paginator", 16, 17);
        i0.ɵɵelementStart(3, "div", 18)(4, "div", 19);
        i0.ɵɵelement(5, "input", 20, 21);
        i0.ɵɵelementStart(7, "button", 22);
        i0.ɵɵlistener("click", function SettingTableComponent_mat_toolbar_2_Template_button_click_7_listener() { i0.ɵɵrestoreView(_r21); const ctx_r20 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r20.reload()); });
        i0.ɵɵelementStart(8, "i")(9, "mat-icon");
        i0.ɵɵtext(10, "search");
        i0.ɵɵelementEnd()()()()()();
    }
    if (rf & 2) {
        i0.ɵɵadvance(1);
        i0.ɵɵproperty("pageIndex", 0)("pageSize", 10)("pageSizeOptions", i0.ɵɵpureFunction0(3, _c1));
    }
}
function SettingTableComponent_mat_toolbar_3_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementStart(0, "mat-toolbar", 15);
        i0.ɵɵelement(1, "div", 23)(2, "mat-paginator", 16, 17);
        i0.ɵɵelementEnd();
    }
    if (rf & 2) {
        i0.ɵɵadvance(2);
        i0.ɵɵproperty("pageIndex", 0)("pageSize", 10)("pageSizeOptions", i0.ɵɵpureFunction0(3, _c1));
    }
}
function SettingTableComponent_mat_header_cell_7_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementStart(0, "mat-header-cell", 24);
        i0.ɵɵtext(1);
        i0.ɵɵpipe(2, "translate");
        i0.ɵɵelementEnd();
    }
    if (rf & 2) {
        i0.ɵɵadvance(1);
        i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "SETTING.HEADER.SETTING_NAME"));
    }
}
function SettingTableComponent_mat_cell_8_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementStart(0, "mat-cell")(1, "span");
        i0.ɵɵtext(2);
        i0.ɵɵelementEnd()();
    }
    if (rf & 2) {
        const row_r23 = ctx.$implicit;
        i0.ɵɵadvance(2);
        i0.ɵɵtextInterpolate(row_r23 == null ? null : row_r23.name);
    }
}
function SettingTableComponent_mat_header_cell_10_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementStart(0, "mat-header-cell", 24);
        i0.ɵɵtext(1);
        i0.ɵɵpipe(2, "translate");
        i0.ɵɵelementEnd();
    }
    if (rf & 2) {
        i0.ɵɵadvance(1);
        i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "SETTING.HEADER.MODULE"));
    }
}
function SettingTableComponent_mat_cell_11_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementStart(0, "mat-cell")(1, "span");
        i0.ɵɵtext(2);
        i0.ɵɵelementEnd()();
    }
    if (rf & 2) {
        const row_r24 = ctx.$implicit;
        i0.ɵɵadvance(2);
        i0.ɵɵtextInterpolate(row_r24 == null ? null : row_r24.module);
    }
}
function SettingTableComponent_mat_header_cell_13_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementStart(0, "mat-header-cell", 24);
        i0.ɵɵtext(1);
        i0.ɵɵpipe(2, "translate");
        i0.ɵɵelementEnd();
    }
    if (rf & 2) {
        i0.ɵɵadvance(1);
        i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "SETTING.HEADER.VALUE"));
    }
}
function SettingTableComponent_mat_cell_14_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementStart(0, "mat-cell")(1, "span");
        i0.ɵɵtext(2);
        i0.ɵɵelementEnd()();
    }
    if (rf & 2) {
        const row_r25 = ctx.$implicit;
        i0.ɵɵadvance(2);
        i0.ɵɵtextInterpolate(row_r25 == null ? null : row_r25.value);
    }
}
function SettingTableComponent_mat_header_cell_16_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementStart(0, "mat-header-cell", 24);
        i0.ɵɵtext(1);
        i0.ɵɵpipe(2, "translate");
        i0.ɵɵelementEnd();
    }
    if (rf & 2) {
        i0.ɵɵadvance(1);
        i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "SETTING.HEADER.ORG"));
    }
}
function SettingTableComponent_mat_cell_17_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementStart(0, "mat-cell")(1, "span");
        i0.ɵɵtext(2);
        i0.ɵɵelementEnd()();
    }
    if (rf & 2) {
        const row_r26 = ctx.$implicit;
        i0.ɵɵadvance(2);
        i0.ɵɵtextInterpolate(row_r26 == null ? null : row_r26.orgId);
    }
}
function SettingTableComponent_mat_header_cell_19_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementStart(0, "mat-header-cell", 24);
        i0.ɵɵtext(1);
        i0.ɵɵpipe(2, "translate");
        i0.ɵɵelementEnd();
    }
    if (rf & 2) {
        i0.ɵɵadvance(1);
        i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "SETTING.HEADER.CHANGE_DATE"));
    }
}
function SettingTableComponent_mat_cell_20_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementStart(0, "mat-cell");
        i0.ɵɵelement(1, "base-date", 25);
        i0.ɵɵelementEnd();
    }
    if (rf & 2) {
        const row_r27 = ctx.$implicit;
        i0.ɵɵadvance(1);
        i0.ɵɵproperty("data", row_r27.change == null ? null : row_r27.change.date)("matTooltip", row_r27.change == null ? null : row_r27.change.user);
    }
}
function SettingTableComponent_mat_header_cell_22_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementStart(0, "mat-header-cell", 24);
        i0.ɵɵtext(1);
        i0.ɵɵpipe(2, "translate");
        i0.ɵɵelementEnd();
    }
    if (rf & 2) {
        i0.ɵɵadvance(1);
        i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "COMMON.CREATED_DATE"));
    }
}
function SettingTableComponent_mat_cell_23_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementStart(0, "mat-cell");
        i0.ɵɵelement(1, "base-date", 25);
        i0.ɵɵelementEnd();
    }
    if (rf & 2) {
        const row_r28 = ctx.$implicit;
        i0.ɵɵadvance(1);
        i0.ɵɵproperty("data", row_r28.created == null ? null : row_r28.created.date)("matTooltip", row_r28.created == null ? null : row_r28.created.user);
    }
}
function SettingTableComponent_ng_container_24_mat_header_cell_1_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementStart(0, "mat-header-cell");
        i0.ɵɵtext(1);
        i0.ɵɵelementEnd();
    }
    if (rf & 2) {
        const column_r29 = i0.ɵɵnextContext().$implicit;
        i0.ɵɵadvance(1);
        i0.ɵɵtextInterpolate(column_r29.header);
    }
}
function SettingTableComponent_ng_container_24_mat_cell_3_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelement(0, "mat-cell", 30);
    }
    if (rf & 2) {
        const row_r33 = ctx.$implicit;
        const column_r29 = i0.ɵɵnextContext().$implicit;
        i0.ɵɵproperty("innerHTML", column_r29.cell(row_r33), i0.ɵɵsanitizeHtml);
    }
}
function SettingTableComponent_ng_container_24_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementContainerStart(0, 26);
        i0.ɵɵtemplate(1, SettingTableComponent_ng_container_24_mat_header_cell_1_Template, 2, 1, "mat-header-cell", 27);
        i0.ɵɵelementStart(2, "div", 28);
        i0.ɵɵtemplate(3, SettingTableComponent_ng_container_24_mat_cell_3_Template, 1, 1, "mat-cell", 29);
        i0.ɵɵelementEnd();
        i0.ɵɵelementContainerEnd();
    }
    if (rf & 2) {
        const column_r29 = ctx.$implicit;
        i0.ɵɵproperty("cdkColumnDef", column_r29.columnDef);
    }
}
function SettingTableComponent_mat_header_row_25_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelement(0, "mat-header-row");
    }
}
function SettingTableComponent_mat_row_26_Template(rf, ctx) {
    if (rf & 1) {
        const _r37 = i0.ɵɵgetCurrentView();
        i0.ɵɵelementStart(0, "mat-row", 31);
        i0.ɵɵlistener("click", function SettingTableComponent_mat_row_26_Template_mat_row_click_0_listener() { const restoredCtx = i0.ɵɵrestoreView(_r37); const row_r35 = restoredCtx.$implicit; const ctx_r36 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r36.onAction("select", row_r35)); });
        i0.ɵɵelementEnd();
    }
}
const _c2 = ["*"];
const TAG = 'UserTableComponent';
class SettingTableComponent {
    constructor(_service) {
        this._service = _service;
        this.displayedColumns = ['name', 'module', 'value', 'change.date'];
        this.filter = {};
        this.showToolbar = true;
        this.action = new EventEmitter();
    }
    ngOnInit() {
        if (this.customColumns && this.customColumns.length > 0) {
            let columnDef = this.customColumns.map(c => c.columnDef);
            this.displayedColumns.push(...columnDef);
        }
    }
    ngAfterViewInit() {
        let filter = this.filter;
        if (!this.dataSource) {
            this.dataSource = new SettingQueryStore(this._service, this.paginator, this.sort, filter);
            //queryStore(this._service, this.paginator, this.sort, filter);
        }
        if (this.searchElem) {
            fromEvent(this.searchElem.nativeElement, 'keyup')
                .pipe(debounceTime(1000), distinctUntilChanged())
                .subscribe(event => {
                let value = this.searchElem.nativeElement.value;
                if (value == '')
                    value = null;
                // let filter = this.dataSource.filterSubject.value;
                let filter = this.filter;
                filter.keyword = value;
                this.reload();
            });
        }
    }
    reload() {
        this.dataSource.reload();
    }
    onAction(type, payload) {
        this.action.emit({ type: type, value: payload });
    }
}
/** @nocollapse */ SettingTableComponent.ɵfac = function SettingTableComponent_Factory(t) { return new (t || SettingTableComponent)(i0.ɵɵdirectiveInject(SettingService)); };
/** @nocollapse */ SettingTableComponent.ɵcmp = /** @pureOrBreakMyCode */ i0.ɵɵdefineComponent({ type: SettingTableComponent, selectors: [["main-setting-table"]], viewQuery: function SettingTableComponent_Query(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵviewQuery(MatPaginator, 5);
            i0.ɵɵviewQuery(MatSort, 5);
            i0.ɵɵviewQuery(_c0, 5);
        }
        if (rf & 2) {
            let _t;
            i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.paginator = _t.first);
            i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.sort = _t.first);
            i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.searchElem = _t.first);
        }
    }, inputs: { displayedColumns: "displayedColumns", filter: "filter", dataSource: "dataSource", showToolbar: "showToolbar", customColumns: "customColumns" }, outputs: { action: "action" }, ngContentSelectors: _c2, decls: 27, vars: 6, consts: [[1, "table-layout-1", "setting-table-layout"], ["class", "primary-300--bg", "fxLayoutAlign", "space-between center", 4, "ngIf"], ["matSort", "", "matSortActive", "change.date", "matSortDirection", "desc", "matSortDisableClear", "", 1, "table-hover-1", 3, "dataSource"], ["table", ""], ["matColumnDef", "name"], ["mat-sort-header", "", 4, "matHeaderCellDef"], [4, "matCellDef"], ["matColumnDef", "module"], ["matColumnDef", "value"], ["matColumnDef", "orgId"], ["matColumnDef", "change.date"], ["matColumnDef", "created.date"], [3, "cdkColumnDef", 4, "ngFor", "ngForOf"], [4, "matHeaderRowDef"], [3, "click", 4, "matRowDef", "matRowDefColumns"], ["fxLayoutAlign", "space-between center", 1, "primary-300--bg"], [3, "pageIndex", "pageSize", "pageSizeOptions"], ["paginator", ""], [1, "field-wrap"], [1, "field-box", "trans-icon"], ["type", "text"], ["searchField", ""], ["type", "button", 3, "click"], ["fxFlex", "1 1 auto"], ["mat-sort-header", ""], ["format", "date", "formatTip", "false", 3, "data", "matTooltip"], [3, "cdkColumnDef"], [4, "cdkHeaderCellDef"], ["id", "observe-wrapper"], [3, "innerHTML", 4, "cdkCellDef"], [3, "innerHTML"], [3, "click"]], template: function SettingTableComponent_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵprojectionDef();
            i0.ɵɵelementStart(0, "div", 0);
            i0.ɵɵprojection(1);
            i0.ɵɵtemplate(2, SettingTableComponent_mat_toolbar_2_Template, 11, 4, "mat-toolbar", 1);
            i0.ɵɵtemplate(3, SettingTableComponent_mat_toolbar_3_Template, 4, 4, "mat-toolbar", 1);
            i0.ɵɵelementStart(4, "mat-table", 2, 3);
            i0.ɵɵelementContainerStart(6, 4);
            i0.ɵɵtemplate(7, SettingTableComponent_mat_header_cell_7_Template, 3, 3, "mat-header-cell", 5);
            i0.ɵɵtemplate(8, SettingTableComponent_mat_cell_8_Template, 3, 1, "mat-cell", 6);
            i0.ɵɵelementContainerEnd();
            i0.ɵɵelementContainerStart(9, 7);
            i0.ɵɵtemplate(10, SettingTableComponent_mat_header_cell_10_Template, 3, 3, "mat-header-cell", 5);
            i0.ɵɵtemplate(11, SettingTableComponent_mat_cell_11_Template, 3, 1, "mat-cell", 6);
            i0.ɵɵelementContainerEnd();
            i0.ɵɵelementContainerStart(12, 8);
            i0.ɵɵtemplate(13, SettingTableComponent_mat_header_cell_13_Template, 3, 3, "mat-header-cell", 5);
            i0.ɵɵtemplate(14, SettingTableComponent_mat_cell_14_Template, 3, 1, "mat-cell", 6);
            i0.ɵɵelementContainerEnd();
            i0.ɵɵelementContainerStart(15, 9);
            i0.ɵɵtemplate(16, SettingTableComponent_mat_header_cell_16_Template, 3, 3, "mat-header-cell", 5);
            i0.ɵɵtemplate(17, SettingTableComponent_mat_cell_17_Template, 3, 1, "mat-cell", 6);
            i0.ɵɵelementContainerEnd();
            i0.ɵɵelementContainerStart(18, 10);
            i0.ɵɵtemplate(19, SettingTableComponent_mat_header_cell_19_Template, 3, 3, "mat-header-cell", 5);
            i0.ɵɵtemplate(20, SettingTableComponent_mat_cell_20_Template, 2, 2, "mat-cell", 6);
            i0.ɵɵelementContainerEnd();
            i0.ɵɵelementContainerStart(21, 11);
            i0.ɵɵtemplate(22, SettingTableComponent_mat_header_cell_22_Template, 3, 3, "mat-header-cell", 5);
            i0.ɵɵtemplate(23, SettingTableComponent_mat_cell_23_Template, 2, 2, "mat-cell", 6);
            i0.ɵɵelementContainerEnd();
            i0.ɵɵtemplate(24, SettingTableComponent_ng_container_24_Template, 4, 1, "ng-container", 12);
            i0.ɵɵtemplate(25, SettingTableComponent_mat_header_row_25_Template, 1, 0, "mat-header-row", 13);
            i0.ɵɵtemplate(26, SettingTableComponent_mat_row_26_Template, 1, 0, "mat-row", 14);
            i0.ɵɵelementEnd()();
        }
        if (rf & 2) {
            i0.ɵɵadvance(2);
            i0.ɵɵproperty("ngIf", ctx.showToolbar);
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("ngIf", !ctx.showToolbar);
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("dataSource", ctx.dataSource);
            i0.ɵɵadvance(20);
            i0.ɵɵproperty("ngForOf", ctx.customColumns);
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("matHeaderRowDef", ctx.displayedColumns);
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("matRowDefColumns", ctx.displayedColumns);
        }
    }, dependencies: [i4.NgForOf, i4.NgIf, i2.MatTable, i2.MatHeaderCellDef, i2.MatHeaderRowDef, i2.MatColumnDef, i2.MatCellDef, i2.MatRowDef, i2.MatHeaderCell, i2.MatCell, i2.MatHeaderRow, i2.MatRow, i3$1.MatTooltip, i4$1.MatPaginator, i5$1.MatSort, i5$1.MatSortHeader, i6$1.MatToolbar, i7.MatIcon, i12.DefaultLayoutAlignDirective, i12.DefaultFlexDirective, i10$1.BaseDateComponent, i11$1.CdkCellDef, i11$1.CdkHeaderCellDef, i11$1.CdkColumnDef, i1.TranslatePipe], encapsulation: 2 });
(function () {
    (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SettingTableComponent, [{
            type: Component,
            args: [{ selector: 'main-setting-table', encapsulation: ViewEncapsulation.None, template: "<div class=\"table-layout-1 setting-table-layout\">\n\n    <ng-content></ng-content>\n\n    <mat-toolbar *ngIf=\"showToolbar\" class=\"primary-300--bg\" fxLayoutAlign=\"space-between center\">\n        <mat-paginator #paginator [pageIndex]=\"0\" [pageSize]=\"10\" [pageSizeOptions]=\"[5, 10, 25, 100]\">\n        </mat-paginator>\n        <div class=\"field-wrap\">\n            <div class=\"field-box trans-icon\">\n                <input #searchField type=\"text\"/>\n                <button (click)=\"reload()\" type=\"button\">\n                    <i>\n                        <mat-icon>search</mat-icon>\n                    </i>\n                </button>\n            </div>\n        </div>\n    </mat-toolbar>\n\n    <mat-toolbar *ngIf=\"!showToolbar\" class=\"primary-300--bg\" fxLayoutAlign=\"space-between center\">\n        <div fxFlex=\"1 1 auto\"></div>\n        <mat-paginator #paginator [pageIndex]=\"0\" [pageSize]=\"10\" [pageSizeOptions]=\"[5, 10, 25, 100]\">\n        </mat-paginator>\n    </mat-toolbar>\n\n    <mat-table class=\"table-hover-1\" #table [dataSource]=\"dataSource\" matSort\n               matSortActive=\"change.date\"\n               matSortDirection=\"desc\"\n               matSortDisableClear>\n\n        <!-- SETTINGname Column -->\n        <ng-container matColumnDef=\"name\">\n            <mat-header-cell mat-sort-header\n                             *matHeaderCellDef>{{'SETTING.HEADER.SETTING_NAME' | translate}}</mat-header-cell>\n            <mat-cell *matCellDef=\"let row\"><span>{{row?.name}}</span></mat-cell>\n        </ng-container>\n\n        <!-- firstName Column -->\n        <ng-container matColumnDef=\"module\">\n            <mat-header-cell mat-sort-header\n                             *matHeaderCellDef>{{'SETTING.HEADER.MODULE' | translate}}</mat-header-cell>\n            <mat-cell *matCellDef=\"let row\"><span>{{row?.module}}</span></mat-cell>\n        </ng-container>\n\n        <!-- lastName Column -->\n        <ng-container matColumnDef=\"value\">\n            <mat-header-cell mat-sort-header\n                             *matHeaderCellDef>{{'SETTING.HEADER.VALUE' | translate}}</mat-header-cell>\n            <mat-cell *matCellDef=\"let row\"><span>{{row?.value}}</span></mat-cell>\n        </ng-container>\n        <!-- groups Column -->\n        <ng-container matColumnDef=\"orgId\">\n            <mat-header-cell mat-sort-header\n                             *matHeaderCellDef>{{'SETTING.HEADER.ORG' | translate}}</mat-header-cell>\n            <mat-cell *matCellDef=\"let row\"><span>{{row?.orgId}}</span></mat-cell>\n        </ng-container>\n\n        <!-- created date Column -->\n        <ng-container matColumnDef=\"change.date\">\n            <mat-header-cell mat-sort-header\n                             *matHeaderCellDef>{{'SETTING.HEADER.CHANGE_DATE' | translate}}</mat-header-cell>\n            <!--<mat-cell *matCellDef=\"let row\"><span>{{row?.change?.date | date:'shortDate'}}</span></mat-cell>-->\n            <mat-cell *matCellDef=\"let row\">\n                <base-date [data]=\"row.change?.date\" format=\"date\" formatTip=\"false\"\n                           [matTooltip]=\"row.change?.user\"></base-date>\n            </mat-cell>\n        </ng-container>\n\n        <ng-container matColumnDef=\"created.date\">\n            <mat-header-cell mat-sort-header *matHeaderCellDef>{{'COMMON.CREATED_DATE' | translate}}</mat-header-cell>\n            <!--<mat-cell *matCellDef=\"let row\"><span>{{row?.change?.date | date:'shortDate'}}</span></mat-cell>-->\n            <mat-cell *matCellDef=\"let row\">\n                <base-date [data]=\"row.created?.date\" format=\"date\" formatTip=\"false\"\n                           [matTooltip]=\"row.created?.user\"></base-date>\n            </mat-cell>\n        </ng-container>\n\n        <!--custom columns -->\n        <ng-container *ngFor=\"let column of customColumns\" [cdkColumnDef]=\"column.columnDef\">\n            <mat-header-cell *cdkHeaderCellDef>{{ column.header }}</mat-header-cell>\n            <div id=\"observe-wrapper\">\n                <mat-cell *cdkCellDef=\"let row\" [innerHTML]=\"column.cell(row)\"></mat-cell>\n            </div>\n        </ng-container>\n\n\n        <mat-header-row *matHeaderRowDef=\"displayedColumns\"></mat-header-row>\n        <mat-row *matRowDef=\"let row; columns: displayedColumns;\" (click)=\"onAction('select', row)\">\n        </mat-row>\n\n    </mat-table>\n\n</div>\n\n\n\n" }]
        }], function () { return [{ type: SettingService }]; }, { displayedColumns: [{
                type: Input
            }], filter: [{
                type: Input
            }], dataSource: [{
                type: Input
            }], showToolbar: [{
                type: Input
            }], action: [{
                type: Output
            }], paginator: [{
                type: ViewChild,
                args: [MatPaginator, { static: false }]
            }], sort: [{
                type: ViewChild,
                args: [MatSort, { static: false }]
            }], searchElem: [{
                type: ViewChild,
                args: ['searchField', { static: false }]
            }], customColumns: [{
                type: Input
            }] });
})();

class MainSettingModule {
}
/** @nocollapse */ MainSettingModule.ɵfac = function MainSettingModule_Factory(t) { return new (t || MainSettingModule)(); };
/** @nocollapse */ MainSettingModule.ɵmod = /** @pureOrBreakMyCode */ i0.ɵɵdefineNgModule({ type: MainSettingModule });
/** @nocollapse */ MainSettingModule.ɵinj = /** @pureOrBreakMyCode */ i0.ɵɵdefineInjector({ imports: [CommonModule,
        TranslateModule.forChild({}),
        ReactiveFormsModule,
        MatCardModule,
        MatTableModule,
        MatTooltipModule,
        MatPaginatorModule,
        MatSortModule,
        MatToolbarModule,
        MatButtonModule,
        MatIconModule,
        FlexLayoutModule,
        FormsModule,
        ChainBaseComp,
        CdkTableModule] });
(function () {
    (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MainSettingModule, [{
            type: NgModule,
            args: [{
                    imports: [
                        CommonModule,
                        TranslateModule.forChild({}),
                        ReactiveFormsModule,
                        MatCardModule,
                        MatTableModule,
                        MatTooltipModule,
                        MatPaginatorModule,
                        MatSortModule,
                        MatToolbarModule,
                        MatButtonModule,
                        MatIconModule,
                        FlexLayoutModule,
                        FormsModule,
                        ChainBaseComp,
                        CdkTableModule
                    ],
                    declarations: [
                        SettingTableComponent
                    ],
                    exports: [
                        SettingTableComponent
                    ], schemas: [NO_ERRORS_SCHEMA]
                }]
        }], null, null);
})();
(function () {
    (typeof ngJitMode === "undefined" || ngJitMode) && i0.ɵɵsetNgModuleScope(MainSettingModule, { declarations: [SettingTableComponent], imports: [CommonModule, i1.TranslateModule, ReactiveFormsModule,
            MatCardModule,
            MatTableModule,
            MatTooltipModule,
            MatPaginatorModule,
            MatSortModule,
            MatToolbarModule,
            MatButtonModule,
            MatIconModule,
            FlexLayoutModule,
            FormsModule,
            ChainBaseComp,
            CdkTableModule], exports: [SettingTableComponent] });
})();

/**
 * Data source for the settings table view. This class should
 * encapsulate all logic for fetching and manipulating the displayed data
 * (including sorting, pagination, and filtering).
 */
class SettingTableDatasource extends QueryTableSource {
    constructor(settingService, paginator, sort, filter = {}) {
        super(paginator, sort, filter);
        this.settingService = settingService;
        this.paginator = paginator;
        this.sort = sort;
        this.filter = filter;
    }
    queryTable() {
        let filter = this.findFilter();
        this.applyFilter(filter);
        return this.settingService.querySettings(filter);
    }
    initReloadMutations() {
        // server-side filtering
        return [this.filterSubject];
        // all client-side
        //return [];
    }
    searchData(data) {
        let filter = this.findFilter();
        if (filter.keyword) {
            console.debug(this.constructor.name, "searchData:", filter);
            //let regEx = new RegExp("^"+filter.keyword.replace('*', '.*'), 'i');
            let regEx = new RegExp(filter.keyword.replace('*', '.*'), 'i');
            data = data.filter(value => regEx.test(value.name)
                || regEx.test(value.shortName)
                || regEx.test(value.desc));
        }
        return super.searchData(data);
    }
}

/*
 * Public API Surface of test
 */

/**
 * Generated bundle index. Do not edit.
 */

export { ChainMainLabel, GroupService, GroupTableComponent, GroupTableQueryStore, LabelEditService, LabelTableComponent, LabelingComponent, MainGroupModule, MainSettingModule, MainUserModule, SettingQueryStore, SettingService, SettingTableComponent, SettingTableDatasource, UserQueryStore, UserService, UserTableComponent };
//# sourceMappingURL=yukawa-chain-main-angular-comp.mjs.map
