import { ElementRef, EventEmitter, OnInit } from '@angular/core';
import { MatPaginator } from "@angular/material/paginator";
import { MatSort } from "@angular/material/sort";
import { Group, GroupFilter } from "@yukawa/chain-main-angular-core";
import { FilteredTableSource } from "@yukawa/chain-base-angular-store";
import { GroupService } from "../group.service";
import * as i0 from "@angular/core";
export declare class GroupTableComponent implements OnInit {
    private _service;
    displayedColumns: string[];
    filter: GroupFilter;
    dataSource: FilteredTableSource<GroupFilter, Group>;
    showToolbar: boolean;
    action: EventEmitter<any>;
    paginator: MatPaginator;
    sort: MatSort;
    searchElem: ElementRef;
    constructor(_service: GroupService);
    ngOnInit(): void;
    reload(): void;
    onAction(type: any, payload: any): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<GroupTableComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<GroupTableComponent, "main-group-table", never, { "displayedColumns": "displayedColumns"; "filter": "filter"; "dataSource": "dataSource"; "showToolbar": "showToolbar"; }, { "action": "action"; }, never, ["*"], false>;
}
