import { BehaviorSubject } from "rxjs";
import { Label } from "@yukawa/chain-base-angular-domain";
import * as i0 from "@angular/core";
export declare class LabelEditService {
    private _labelManagementShown;
    private _selectedLabels;
    constructor();
    showLabelManagement(): void;
    hideLabelManagement(): void;
    toggleLabelManagement(): void;
    get labelManagementShown(): BehaviorSubject<boolean>;
    get selectedLabels(): BehaviorSubject<Label[]>;
    setSelectedLabels(labels: Label[]): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<LabelEditService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<LabelEditService>;
}
