import { QueryTableSource } from "@yukawa/chain-base-angular-store";
import { MatPaginator } from "@angular/material/paginator";
import { MatSort } from "@angular/material/sort";
import { Observable } from "rxjs";
import { Setting, SettingAspect, SettingFilter } from "@yukawa/chain-main-angular-core";
export declare class SettingQueryStore extends QueryTableSource<SettingFilter, Setting> {
    protected service: SettingAspect;
    protected paginator?: MatPaginator;
    protected sort?: MatSort;
    protected tableFilter?: any;
    constructor(service: SettingAspect, paginator?: MatPaginator, sort?: MatSort, tableFilter?: any);
    protected queryTable(): Observable<any>;
}
