import { AfterViewInit, ElementRef, EventEmitter, OnInit } from '@angular/core';
import { MatPaginator } from "@angular/material/paginator";
import { MatSort } from "@angular/material/sort";
import { Setting, SettingFilter } from "@yukawa/chain-main-angular-core";
import { FilteredTableSource } from "@yukawa/chain-base-angular-store";
import { SettingService } from "../setting.service";
import * as i0 from "@angular/core";
export declare class SettingTableComponent implements OnInit, AfterViewInit {
    private _service;
    displayedColumns: string[];
    filter: SettingFilter;
    dataSource: FilteredTableSource<SettingFilter, Setting>;
    showToolbar: boolean;
    action: EventEmitter<any>;
    paginator: MatPaginator;
    sort: MatSort;
    searchElem: ElementRef;
    customColumns: any[];
    constructor(_service: SettingService);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    reload(): void;
    onAction(type: any, payload: any): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<SettingTableComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<SettingTableComponent, "main-setting-table", never, { "displayedColumns": "displayedColumns"; "filter": "filter"; "dataSource": "dataSource"; "showToolbar": "showToolbar"; "customColumns": "customColumns"; }, { "action": "action"; }, never, ["*"], false>;
}
