import { ElementRef, EventEmitter, OnInit } from '@angular/core';
import { MatPaginator } from "@angular/material/paginator";
import { MatSort } from "@angular/material/sort";
import { User, UserFilter } from "@yukawa/chain-main-angular-core";
import { FilteredTableSource } from "@yukawa/chain-base-angular-store";
import { UserService } from "../user.service";
import * as i0 from "@angular/core";
export declare class UserTableComponent implements OnInit {
    private _service;
    displayedColumns: string[];
    filter: UserFilter;
    dataSource: FilteredTableSource<UserFilter, User>;
    showToolbar: boolean;
    action: EventEmitter<any>;
    paginator: MatPaginator;
    sort: MatSort;
    searchElem: ElementRef;
    constructor(_service: UserService);
    ngOnInit(): void;
    reload(): void;
    onAction(type: any, payload: any): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<UserTableComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<UserTableComponent, "main-user-table", never, { "displayedColumns": "displayedColumns"; "filter": "filter"; "dataSource": "dataSource"; "showToolbar": "showToolbar"; }, { "action": "action"; }, never, ["*"], false>;
}
