import { MatPaginator } from "@angular/material/paginator";
import { MatSort } from "@angular/material/sort";
import { Observable } from "rxjs";
import { QueryResult } from "@yukawa/chain-base-angular-domain";
import { QueryTableSource } from "@yukawa/chain-base-angular-store";
import { Group, GroupAspect, GroupFilter } from "@yukawa/chain-main-angular-core";
export declare class GroupTableQueryStore extends QueryTableSource<GroupFilter, Group> {
    protected service: GroupAspect;
    protected paginator?: MatPaginator;
    protected sort?: MatSort;
    protected tableFilter?: GroupFilter;
    constructor(service: GroupAspect, paginator?: MatPaginator, sort?: MatSort, tableFilter?: GroupFilter);
    protected queryTable(): Observable<QueryResult<Group>>;
}
