import { Observable } from 'rxjs';
import { HttpClient } from '@angular/common/http';
import { GroupAspect } from '@yukawa/chain-main-angular-core';
import { ConfigService, RestAspect } from "@yukawa/chain-base-angular-client";
import { Group, GroupFilter } from "@yukawa/chain-main-angular-core";
import { EditResult } from "@yukawa/chain-base-angular-domain";
import * as i0 from "@angular/core";
export declare class GroupService extends RestAspect implements GroupAspect {
    protected http: HttpClient;
    protected configService: ConfigService;
    constructor(http: HttpClient, configService: ConfigService);
    loadGroup(name: any): Observable<Group>;
    editGroup(group: Group): Observable<EditResult>;
    queryGroups(filter: GroupFilter): Observable<any>;
    deleteGroup(name: string): Observable<any>;
    updateGroup(group: Group): Observable<any>;
    createGroup(value: Group | any): Observable<EditResult>;
    protected formatServiceUrl(path?: string): string;
    static ɵfac: i0.ɵɵFactoryDeclaration<GroupService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<GroupService>;
}
