import { QueryTableSource } from "@yukawa/chain-base-angular-store";
import { MatPaginator } from "@angular/material/paginator";
import { MatSort } from "@angular/material/sort";
import { Observable } from "rxjs";
import { User, UserAspect, UserFilter } from "@yukawa/chain-main-angular-core";
export declare class UserQueryStore extends QueryTableSource<UserFilter, User> {
    protected service: UserAspect;
    protected paginator?: MatPaginator;
    protected sort?: MatSort;
    protected tableFilter?: any;
    constructor(service: UserAspect, paginator?: MatPaginator, sort?: MatSort, tableFilter?: any);
    protected queryTable(): Observable<any>;
}
